<?php
require_once('constants.php');

require 'autoload.php';
require 'src/Helpers.php';

class resourcesClass{

    public $salt = '&*%@#0%';
    var $error = 0;
    var $error_stmt = "";
    var $client = constants::EXT_REQ;
    var $api_key = '';
    var $date; //$time = date('Y-m-d H:i:s');

    var $data = array();
    const DB_ERR = 1;
    const ERR = 2;
    const ERR_PREP = 3;
    const ERR_NO_VALUE = 4;
    const ERR_FILE = 5;
    const ERR_API_KEY = 6;
    const ERR_FB = 7;
    const ERR_SESSION_EXP = 10;
    const SESSION_EXPIRED = "Session expired";
    const SESSION_DURATION = 60*60*24*365;
    const PRODUCT_FORUM = "product";
    const EVENT_FORUM = "event";
    const SERVICE_FORUM = "service";

    protected function dbConnect(){
        $db = new mysqli(constants::DB_HOST, constants::DB_USER, constants::DB_PASSWORD, constants::DB_NAME);
        $this->date = date('Y-m-d H:i:s');
        //connect to DB, return either DB object or false
        if($db->connect_errno > 0){
            $this->dbError();
        }else{
            return $db;
        }
        //return ($db->connect_errno > 0) ? false : $db;
    }
    
    function __construct(){
        \Cloudinary::config(array(
            "cloud_name" => "dmtsglrak",
            "api_key" => "294656626465939",
            "api_secret" => "EbP5VAgpbxalf3QLMyMH0qgPzZY",
            "secure" => true
        ));
    }

    function getBaseUrl(){
        $str = $_SERVER['SERVER_NAME'];
        if($str=="localhost"){
            $server_name = "localhost/charterhall";
        }else{
            $server_name = $_SERVER['SERVER_NAME'];
        }

        if(isset($_SERVER['HTTPS'])){
            $protocol = ($_SERVER['HTTPS'] && $_SERVER['HTTPS'] != "off") ? "https" : "http";
        }
        else{
            $protocol = 'http';
        }

        $base = $protocol."://".$server_name;
        return $base;
    }

    function verifyKey($key){
        $db = $this->dbConnect();

        $salt=constants::SALT;
        $key = sha1($salt.$key);

        $query="select * from api_key where token = '$key'";
        $stmt=$db->query($query);
        $num = $stmt->num_rows;

        return $num > 0?true:false;

    }

    function generateSessionID(){
        session_start();
        session_regenerate_id();
        return session_id();

    }

    function base64_to_img($base64_string, $output_file, $ext) {

        // split the string on commas
        // $data[ 0 ] == "data:image/png;base64"
        // $data[ 1 ] == <actual base64 string>
        $data = explode( ',', $base64_string );

        // open the output file for writing
        //$subst = substr($data[0],0,12);
        $ext = '.'.$ext;

        $_file = $output_file.$ext;

        if(file_exists($_file)){
            $u1 = round(microtime(true));
            $_file = $output_file.$u1.$ext;
        }

        $fp = file_put_contents($_file, base64_decode( $data[ 1 ] ));

        if(!$fp){
            return false;
        }else{
            return $_file;
        }

    }

    function uploadFileBase64Format($vals){

        $dataString = $vals['image'];
        $remove = $vals['remove'];
        $original = $vals['original'];

        if(substr($dataString,0,4)==="data"){
            $data = explode( ',', $dataString );
            $dataString = $data[1];
        }

        //echo $dataString;die();

        $ext = ".jpg";
        session_start();
        session_regenerate_id();
        $session_id = session_id();
        $base_file = $session_id.$ext;
        $filename = constants::IMG_FOLDER.$base_file; // local
        $thumb = constants::IMG_THUMB.$base_file;
        //$filename = "api/src/routes/uploads/android_".time().$ext; // online

        //$encoded = str_replace(" ", "+", $_POST['image']);
        $encoded = str_replace(" ", "+", $dataString);
        //$encoded = $fileData;

        $binarydata = base64_decode($encoded);

        //echo $binarydata; die();

        //$this->resizeImageData($binarydata,$thumb);


        //convert image string to image itself and store...
        //$result = file_put_contents($filename, $binarydata);

        if($remove!=="yes"){
            //$this->resizeImageData($binarydata,$filename,1000);
            $optn['file_data'] = $binarydata;
            $optn['file_name'] = $filename;
            $optn['new_width'] = 1000;

            if($original==1){
                $optn['original'] = 1;
            }

            $this->resizeImageData2($optn);
        }

        //then create its thumbnail
        //$result = $this->resizeImageData($binarydata,$thumb,100);
        $opt1['file_data'] = $binarydata;
        $opt1['file_name'] = $thumb;
        $opt1['new_width'] = 100;
        $result = $this->resizeImageData2($opt1);

        if($result){
            return array('image'=>$filename, 'thumbnail'=>$thumb, 'base'=>$base_file);
        }else{
            return false;
        }

    }

    public function resizeImageData2($data){

        $fileData = $data['file_data'];
        $filename = $data['file_name'];
        $new_width = $data['new_width'];

        $original = $data['original'];

        //$filename = $this::IMG_THUMB.'resized_image.png'; // output file name

        //$fileData = base64_decode($fileData);

        $im = imagecreatefromstring($fileData);
        $source_width = imagesx($im);
        $source_height = imagesy($im);
        $ratio =  $source_height / $source_width;

        if($original==1){
            $new_width = $source_width;
        }


        //$new_width = 150; // assign new width to new resized image
        $new_height = $ratio * $new_width;

        $thumb = imagecreatetruecolor($new_width, $new_height);

        $transparency = imagecolorallocatealpha($thumb, 255, 255, 255, 127);
        imagefilledrectangle($thumb, 0, 0, $new_width, $new_height, $transparency);

        imagecopyresampled($thumb, $im, 0, 0, 0, 0, $new_width, $new_height, $source_width, $source_height);
        //$ret = imagepng($thumb, $filename, 9);
        $ret = imagejpeg($thumb,$filename);
        imagedestroy($im);
        return $ret;
    }

    public function resizeImageData($fileData,$filename,$new_width){
        //$filename = $this::IMG_THUMB.'resized_image.png'; // output file name

        //$fileData = base64_decode($fileData);

        $im = imagecreatefromstring($fileData);
        $source_width = imagesx($im);
        $source_height = imagesy($im);
        $ratio =  $source_height / $source_width;


        //$new_width = 150; // assign new width to new resized image
        $new_height = $ratio * $new_width;

        $thumb = imagecreatetruecolor($new_width, $new_height);

        $transparency = imagecolorallocatealpha($thumb, 255, 255, 255, 127);
        imagefilledrectangle($thumb, 0, 0, $new_width, $new_height, $transparency);

        imagecopyresampled($thumb, $im, 0, 0, 0, 0, $new_width, $new_height, $source_width, $source_height);
        //$ret = imagepng($thumb, $filename, 9);
        $ret = imagejpeg($thumb,$filename);
        imagedestroy($im);
        return $ret;
    }

    public function uploadMedia($vals){
        /*$upload_location = "https://www.nistores.com.ng/api/src/routes/";
        $dataString = $vals['image'];

        $ext = ".jpg";
        session_start();

        $session_id = session_id();
        $filename = constants::IMG_FOLDER.$session_id.$ext; // local
        $thumb = constants::IMG_THUMB.$session_id.$ext;
        //$filename = "api/src/routes/uploads/android_".time().$ext; // online

        //$encoded = str_replace(" ", "+", $_POST['image']);
        $encoded = str_replace(" ", "+", $dataString);
        //$encoded = $fileData;

        $binarydata = base64_decode($encoded);

        //$this->resizeImageData($binarydata,$thumb);


        //convert image string to image itself and store...
        //$result = file_put_contents($filename, $binarydata);

        $this->resizeImageData($binarydata,$filename,1000);

        //then create its thumbnail
        $result = $this->resizeImageData($binarydata,$thumb,150);*/

        $result = $this->uploadFileBase64Format($vals);

        if($result===FALSE){
            $this->error = $this::ERR_FILE;
            $this->error_stmt = "Error uploading image";
            if($this->client==constants::INT_REQ){
                return $this->output();
            }
            $this->output();
        }else{
            $this->data = $result;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }
            $this->output();
        }

        /*if($result){
            //echo $filename;
            $res =  array('image'=>$filename, 'thumbnail'=>$thumb);
            $this->data = $res;
            $this->output();

        }else{
            $this->error = $this::ERR_FILE;
            $this->error_stmt = "Error uploading image";
            $this->output();
            //return false;
        }*/

    }

    function returnSingularWord($search){
        $search1 = $search;
        if(substr($search, -1) == "s"){
            $search1 = substr($search,0,strlen($search) - 1);
        }

        if(substr($search, -2) == "es"){
            $search1 = substr($search,0,strlen($search) - 2);
        }

        return $search1;
    }

    function getUserEmail($ref){
        $query="select * from users where reset_link = '$ref' ";
        $result=$this->db->query($query);
        if(!$result){
            return false;
        }
        if($row=$result->fetch_assoc())
        {
            $res = array();
            $res['id'] = $row['id'];
            $res['email'] = $row['email'];
            return $res;

        }else{
            return false;
        }
    }



    function getAdmin($data){
        $db = $this->dbConnect();

        $password = $data['password'];
        $email = $data['email'];

        //$salt=constants::SALT;
        //$password = sha1($salt.$password);
        $query="select * from users where username = '$email' and password='$password'";
        $stmt=$db->query($query);
        $num = $stmt->num_rows;

        if($num>0){

            while($row=$stmt->fetch_assoc()){

                extract($row);
                $this->data = $row;
            }

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();

        }else{
            $this->error = $this::ERR;
            $this->error_stmt = "Invalid email or password";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }
    }

    function getCommentReplies($data){
        $db = $this->dbConnect();
        $forum = $data['forum'];
        $parent = $data['parent'];
        $uid = $data['uid'];

        $res = array();

        /*$query = "SELECT a.mc_id, a.mc_user, a.mc_data, a.mc_link, a.mc_comment, a.mc_date, a.mc_type, a.mc_parent, b.surname, b.firstname, b.picture, COUNT(c.ml_id) AS likes FROM xnx2_253_market_comments a LEFT JOIN xnx2_253_merchants b ON a.mc_user = b.merchant_id LEFT JOIN xnx2_253_market_likes c ON a.mc_id = c.ml_data WHERE a.mc_parent='$parent' OR a.mc_id='$parent' GROUP BY a.mc_id ORDER BY a.mc_id ";*/

        $query = "SELECT a.comment_id AS mc_id, a.comment_user AS mc_user, a.comment_page_id AS mc_data, a.comment_comment AS mc_comment, a.comment_date AS mc_date, a.comment_type AS mc_type, a.comment_parent AS mc_parent, b.surname, b.firstname, b.picture, COUNT(c.likes_id) AS likes FROM comment a LEFT JOIN merchants b ON a.comment_user = b.id LEFT JOIN likes c ON a.comment_id = c.likes_page_id WHERE (a.comment_parent = '$parent' OR a.comment_id='$parent') AND a.comment_forum='$forum' GROUP BY a.comment_id ORDER BY a.comment_id ";

        $stmt = $db->query($query);
        $num = $stmt->num_rows;
        if($num > 0){
            while($row=$stmt->fetch_assoc()){

                $mc_id = $row['comment_id'];
                //if($type=="topic"){
                //check if user likes this comment
                $query4 = "SELECT likes_id FROM likes WHERE likes_user = '$uid' AND likes_page_id = '$mc_id' LIMIT 1 ";
                $stmt4 = $db->query($query4);
                $liked_it = $stmt4->num_rows;

                $row['liked'] = $liked_it;
                //}

                $row['no_of_replies'] = 0;
                $row['extra_replies'] = 0;
                extract($row);
                $res['data'][] = $row;
            }

        }else{
            $res['data'] = array();
        }

        return $res;
    }

    function getComments($data){

        $db = $this->dbConnect();
        $id = $data['id'];
        $uid = $data['uid'];
        $forum = $data['forum'];

        $que = "SELECT comment_id FROM comment WHERE comment_forum='$forum' AND comment_page_id = '$id'";
        $stm = $db->query($que);
        $total_comments = $stm->num_rows;

        //Get comments on the topic
        $query2 = "SELECT a.comment_id AS mc_id, a.comment_user AS mc_user, a.comment_page_id AS mc_data, a.comment_comment AS mc_comment, a.comment_date AS mc_date, a.comment_type AS mc_type, a.comment_parent AS mc_parent, b.surname, b.firstname, b.picture, COUNT(c.likes_id) AS likes FROM comment a LEFT JOIN merchants b ON a.comment_user = b.id LEFT JOIN likes c ON a.comment_id = c.likes_page_id WHERE a.comment_page_id = '$id' AND a.comment_parent='0' AND a.comment_forum='$forum' GROUP BY a.comment_id ";
        $stmt2 = $db->query($query2);
        $num2 = $stmt2->num_rows;

        if($num2 > 0){
            while($row2=$stmt2->fetch_assoc()){
                $parent = $row2['mc_id'];

                //IFNULL(c.stars, '0') as stars

                $query3 = "SELECT a.comment_id AS mc_id, a.comment_user AS mc_user, a.comment_comment AS mc_comment, a.comment_type AS mc_type, a.comment_parent AS mc_parent, IFNULL(b.surname, 'Admin') as surname, IFNULL(b.firstname, '') as firstname, b.picture FROM comment a LEFT JOIN merchants b ON a.comment_user = b.id WHERE a.comment_parent='$parent' ORDER BY a.comment_id";

                //$query3 = "SELECT a.mc_id, a.mc_user, a.mc_comment, a.mc_type, a.mc_parent, b.surname, b.firstname, b.picture FROM xnx2_253_market_comments a LEFT JOIN xnx2_253_merchants b ON a.mc_user = b.merchant_id WHERE a.mc_parent='$parent' ORDER BY a.mc_id";

                $stmt3 = $db->query($query3);
                $num3 = $stmt3->num_rows;
                $row2['no_of_replies'] = $num3;
                $num2 = $num2 + $num3;
                $row2['extra_replies'] = ($num3 > 3)?$num3 - 3:0;
                if($num3 > 0){
                    $reply_cnt = 0;
                    while($row3=$stmt3->fetch_assoc()){
                        if($reply_cnt>2)continue;
                        //extract($row3);
                        //$res['data']['owner'] = $row3;
                        $row2['reply_id'.$reply_cnt] = $row3['mc_id'];
                        $row2['reply_user'.$reply_cnt] = $row3['mc_user'];
                        $row2['reply_comment'.$reply_cnt] = $row3['mc_comment'];
                        $row2['reply_firstname'.$reply_cnt] = $row3['firstname'];
                        $row2['reply_surname'.$reply_cnt] = $row3['surname'];
                        $row2['reply_picture'.$reply_cnt] = $row3['picture'];
                        $reply_cnt++;
                    }
                }

                //check if user likes this comment
                $query4 = "SELECT likes_id FROM likes WHERE likes_user = '$uid' AND likes_page_id = '$parent' LIMIT 1 ";
                $stmt4 = $db->query($query4);
                $liked_it = $stmt4->num_rows;

                $row2['liked'] = $liked_it;

                extract($row2);
                $res['data'][] = $row2;
                //$rez = $row2;

            }
        }else{
            $res['data'] = array();
        }
        //$res['data']['total'] = $total_comments;
        //$res['counted'] = "".$num2."";
        $res['total'] = $total_comments;

        return $res;

    }

    function getAll($data){

        $table = $data['table'];
        $fields = $data['columns'];
        $where_clause = $data['where_clause'];
        $order_by = $data['order_by'];
        $group_by = $data['group_by'];
        $join = $data['join'];
        $limit = $data['limit'];
        $ranking = $data['ranking'];

        $fields = (isset($fields))?$fields:"*";
        $od = " ORDER BY ";
        //$de = " DESC ";
        $de = (isset($ranking))?" ". $ranking . " ":" DESC ";

        //$de = " " . $de . " ";

        $order_by = (isset($order_by))?$od.$order_by.$de:"";

        /*$order_by1 = "";
        if(isset($order_by)){
            $order_by_array = explode(",",$order_by);
            for($x=0;$x<count($order_by_array);$x++){
                if($x>0){
                    $order_by1 .=", ".$order_by_array[$x];
                }else{
                    $order_by1 .=$order_by_array[$x];
                }

                if($x==count($order_by_array) - 1){
                    $order_by1 .= $de . " ";
                }else{
                    $order_by1 .= $de;
                }

                echo $order_by1.'<br>';
            }
        }*/

        /*echo $order_by;
        die();*/

        $gb = " GROUP BY ";
        $group_by = (isset($group_by))?$gb.$group_by:"";

        $db = $this->dbConnect();

        /*
        $query = "SELECT *,b.sname,b.store_uid FROM xnx2_253_payments a LEFT JOIN xnx2_253_stores b ON a.pay_store = b.store_id WHERE a.pay_user = '$user' ORDER BY a.pay_id DESC LIMIT 30 ";

         */

        //$join = "LEFT JOIN state ON university.state = state.id";

        $query = "SELECT " . $fields . " FROM " . $table . " " .$join. " " . $where_clause.$group_by.$order_by. $limit;




        //$query = "SELECT * FROM university a LEFT JOIN state";

        //die($query);

        $stmt = $db->query($query);

        //for debugging
        if(!$stmt){

            /*print_r($db->error_list);
            die();*/

            $this->error = $this::ERR_PREP;
            $this->error_stmt = "Invalid query";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();

        }
        //end debugging

        while($row=$stmt->fetch_assoc()){

            if($table=='product' || $table=='service'){
                $pid = $row['id'];
                /*$query1 = "SELECT source FROM photos WHERE product_id='$pid' LIMIT 1";
                $stmt1 = $db->query($query1);
                $row1=$stmt1->fetch_row();
                $row['picture'] = $row1[0];*/

                $query1 = "SELECT source FROM photos WHERE product_id = '$pid' AND forum = '$table' ";
                $stmt1 = $db->query($query1);
                $cnt = 0;
                while($row1=$stmt1->fetch_assoc()){
                    extract($row1);
                    if($cnt==0){
                        $row['picture']=$row1['source'];
                    }
                    $row['pictures'][] = $row1;
                    $cnt++;
                }

                $row['liked'] = 0;
                if(isset($data['uid'])){
                    $opt['id'] = $pid;
                    $opt['forum'] = ($table=='product')?$this::PRODUCT_FORUM:$this::SERVICE_FORUM;
                    $opt['type'] = 0;
                    $opt['uid'] = $data['uid'];
                    $user_liked = $this->checkUserLike($opt);
                    $row['liked'] = $user_liked;
                }

            }

            if($table=='event'){
                $pid = $row['id'];
                $row['liked'] = 0;
                $opt['id'] = $pid;
                $opt['forum'] = $this::EVENT_FORUM;
                if(isset($data['uid'])){
                    $opt['type'] = 0;
                    $opt['uid'] = $data['uid'];
                    $user_liked = $this->checkUserLike($opt);
                    $row['liked'] = $user_liked;
                }

                $cmts = $this->getComments($opt)['total'];
                $row['comments'] = $cmts;

            }

            if($table=='alert'){
                $alert_state = $row['alert_state'];
                $alert_school = $row['alert_school'];
                $stateArray = explode(",",$alert_state);
                $schoolArray = explode(",",$alert_school);
                $sel_state = array();
                $query_a = "SELECT id,name FROM state";
                $stmt_a = $db->query($query_a);
                while($row_a = $stmt_a->fetch_assoc()){
                    $id_a = $row_a['id'];
                    $name_a = $row_a['name'];
                    if(in_array($id_a,$stateArray)){
                        $sel_state[] = $name_a;
                    }
                }

                $row['alert_state_name'] = implode (", ", $sel_state);

                $sel_sch = array();
                $query_s = "SELECT id,name FROM university";
                $stmt_s = $db->query($query_s);
                while($row_s = $stmt_s->fetch_assoc()){
                    $id_s = $row_s['id'];
                    $name_s = $row_s['name'];
                    if(in_array($id_s,$schoolArray)){
                        $sel_sch[] = $name_s;
                    }
                }

                $row['alert_school_name'] = implode (", ", $sel_sch);

            }

            extract($row);
            $this->data[] = $row;
        }

        if($this->client==constants::INT_REQ){
            return $this->output();
        }

        $this->output();

        /*if($num > 0){


        }else{
            $this->error = $this::ERR_NO_VALUE;
            $this->error_stmt = "No records";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }*/

    }

    function getAll2($data){

        $table = $data['table'];
        $fields = $data['columns'];
        $where_clause = $data['where_clause'];
        $order_by = $data['order_by'];
        $group_by = $data['group_by'];
        $join = $data['join'];
        $limit = $data['limit'];
        $ranking = $data['ranking'];

        $fields = (isset($fields))?$fields:"*";
        $od = " ORDER BY ";
        //$de = " DESC ";
        $de = (isset($ranking))?" ". $ranking . " ":" DESC";

        //$de = " " . $de . " ";

        //$order_by = (isset($order_by))?$od.$order_by.$de:"";

        $order_by1 = "";
        if(isset($order_by)){
            $order_by_array = explode(",",$order_by);
            for($x=0;$x<count($order_by_array);$x++){

                $ss = $order_by_array[$x];
                $ar1 = explode(":",$ss);
                $ar_col = $ar1[0];
                $ar_format = $ar1[1];

                if($x>0){
                    $order_by1 .= ", ".$ar_col;
                }else{
                    $order_by1 .= $ar_col;
                }

                if($x==count($order_by_array) - 1){
                    $order_by1 .= " " . $ar_format . " ";
                }else{
                    $order_by1 .= " " . $ar_format;
                }

                //echo $order_by1.'<br>';
            }

            $order_by1 = (isset($order_by1))?$od.$order_by1:"";
        }

        //echo $order_by1;
        //die();

        $gb = " GROUP BY ";
        $group_by = (isset($group_by))?$gb.$group_by:"";

        $db = $this->dbConnect();

        /*
        $query = "SELECT *,b.sname,b.store_uid FROM xnx2_253_payments a LEFT JOIN xnx2_253_stores b ON a.pay_store = b.store_id WHERE a.pay_user = '$user' ORDER BY a.pay_id DESC LIMIT 30 ";

         */

        //$join = "LEFT JOIN state ON university.state = state.id";

        $query = "SELECT " . $fields . " FROM " . $table . " " .$join. " " . $where_clause.$group_by.$order_by1. $limit;



        //$query = "SELECT * FROM university a LEFT JOIN state";

        //die($query);

        $stmt = $db->query($query);

        //for debugging
        if(!$stmt){

            /*print_r($db->error_list);
            die();*/

            $this->error = $this::ERR_PREP;
            $this->error_stmt = "Invalid query";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();

        }
        //end debugging

        while($row=$stmt->fetch_assoc()){

            if($table=='product' || $table=='service'){
                $pid = $row['id'];
                /*$query1 = "SELECT source FROM photos WHERE product_id='$pid' LIMIT 1";
                $stmt1 = $db->query($query1);
                $row1=$stmt1->fetch_row();
                $row['picture'] = $row1[0];*/

                $query1 = "SELECT source FROM photos WHERE product_id = '$pid' AND forum = '$table' ";
                $stmt1 = $db->query($query1);
                $cnt = 0;
                while($row1=$stmt1->fetch_assoc()){
                    extract($row1);
                    if($cnt==0){
                        $row['picture']=$row1['source'];
                    }
                    $row['pictures'][] = $row1;
                    $cnt++;
                }

                $row['liked'] = 0;
                if(isset($data['uid'])){
                    $opt['id'] = $pid;
                    $opt['forum'] = ($table=='product')?$this::PRODUCT_FORUM:$this::SERVICE_FORUM;
                    $opt['type'] = 0;
                    $opt['uid'] = $data['uid'];
                    $user_liked = $this->checkUserLike($opt);
                    $row['liked'] = $user_liked;
                }

            }

            if($table=='event'){
                $pid = $row['id'];
                $row['liked'] = 0;
                $opt['id'] = $pid;
                $opt['forum'] = $this::EVENT_FORUM;
                if(isset($data['uid'])){
                    $opt['type'] = 0;
                    $opt['uid'] = $data['uid'];
                    $user_liked = $this->checkUserLike($opt);
                    $row['liked'] = $user_liked;
                }

                $cmts = $this->getComments($opt)['total'];
                $row['comments'] = $cmts;

            }

            if($table=='alert'){
                $alert_state = $row['alert_state'];
                $alert_school = $row['alert_school'];
                $stateArray = explode(",",$alert_state);
                $schoolArray = explode(",",$alert_school);
                $sel_state = array();
                $query_a = "SELECT id,name FROM state";
                $stmt_a = $db->query($query_a);
                while($row_a = $stmt_a->fetch_assoc()){
                    $id_a = $row_a['id'];
                    $name_a = $row_a['name'];
                    if(in_array($id_a,$stateArray)){
                        $sel_state[] = $name_a;
                    }
                }

                $row['alert_state_name'] = implode (", ", $sel_state);

                $sel_sch = array();
                $query_s = "SELECT id,name FROM university";
                $stmt_s = $db->query($query_s);
                while($row_s = $stmt_s->fetch_assoc()){
                    $id_s = $row_s['id'];
                    $name_s = $row_s['name'];
                    if(in_array($id_s,$schoolArray)){
                        $sel_sch[] = $name_s;
                    }
                }

                $row['alert_school_name'] = implode (", ", $sel_sch);

            }

            extract($row);
            $this->data[] = $row;
        }

        if($this->client==constants::INT_REQ){
            return $this->output();
        }

        $this->output();

        /*if($num > 0){


        }else{
            $this->error = $this::ERR_NO_VALUE;
            $this->error_stmt = "No records";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }*/

    }

    function getChatPics($data){

    }

    function countData2($data){
        $table = $data['table'];
        $fields = $data['columns'];
        $where_clause = $data['where_clause'];
        $order_by = $data['order_by'];
        $group_by = $data['group_by'];
        $join = $data['join'];
        $limit = $data['limit'];
        $ranking = $data['ranking'];

        $fields = (isset($fields))?$fields:"*";
        $od = " ORDER BY ";
        //$de = " DESC ";
        $de = (isset($ranking))?" ". $ranking . " ":" DESC";


        $order_by1 = "";
        if(isset($order_by)){
            $order_by_array = explode(",",$order_by);
            for($x=0;$x<count($order_by_array);$x++){

                $ss = $order_by_array[$x];
                $ar1 = explode(":",$ss);
                $ar_col = $ar1[0];
                $ar_format = $ar1[1];

                if($x>0){
                    $order_by1 .= ", ".$ar_col;
                }else{
                    $order_by1 .= $ar_col;
                }

                if($x==count($order_by_array) - 1){
                    $order_by1 .= " " . $ar_format . " ";
                }else{
                    $order_by1 .= " " . $ar_format;
                }

                //echo $order_by1.'<br>';
            }

            $order_by1 = (isset($order_by1))?$od.$order_by1:"";
        }

        //echo $order_by1;
        //die();

        $gb = " GROUP BY ";
        $group_by = (isset($group_by))?$gb.$group_by:"";

        $db = $this->dbConnect();

        //$query = "SELECT " . $fields . " FROM " . $table . " " .$join. " " . $where_clause.$group_by.$order_by1. $limit;

        $query = "SELECT " . $fields . " FROM " . $table . " " .$join. " " . $where_clause.$group_by.$order_by1;

        $stmt = $db->query($query);

        $this->data = $stmt->num_rows;
        if($this->client==constants::INT_REQ){
            return $this->output();
        }

        $this->output();

    }

    function countData($data){

        $db = $this->dbConnect();
        $table = $data['table'];
        $fields = $data['columns'];
        $where_clause = $data['where'];
        $order_by = $data['order_by'];
        $join = $data['join'];
        $limit = $data['limit'];

        $fields = (isset($fields))?$fields:"*";
        $order_by = (isset($order_by))?$order_by:"id";

        $query = "SELECT " . $fields . " FROM " . $table . " " .$join. " " . $where_clause." ORDER BY " . $order_by. " DESC " .$limit;
        $stmt = $db->query($query);
        //return $stmt->num_rows;
        $this->data = $stmt->num_rows;
        if($this->client==constants::INT_REQ){
            return $this->output();
        }

        $this->output();

    }

    function getManager($data){
        $email = $data['email'];
        $no = $data['manager_no'];
        $query="select * from managers where email = '$email' and number='$no'";
        $result=$this->db->query($query);
        if(!$result){
            return false;
        }
        if($row=$result->fetch_assoc())
        {
            $res = array();
            $res['id'] = $row['id'];
            $res['email'] = $row['email'];

            return $res;

        }else{
            return false;
        }
    }

    function getMainAdmin($email,$password){
        $salt='&*%@#0%';
        $password = sha1($salt.$password);
        $query="select * from admin where email = '$email' and password='$password' and access_type = 0 ";
        $result=$this->db->query($query);
        if(!$result){
            return false;
        }
        if($row=$result->fetch_assoc())
        {
            $res = array();
            $res['id'] = $row['id'];
            $res['email'] = $row['email'];
            $res['name'] = $row['name'];
            return $res;

        }else{
            return false;
        }
    }

    function checkEmail($email){
        $db = $this->dbConnect();
        $query="select * from merchants where email = '$email' ";
        $stmt=$db->query($query);
        return $stmt->num_rows;
    }

    function checkUserVerification(){

    }

    function loginUser($data){
        $db = $this->dbConnect();

        $password = $data['password'];
        $email = $data['email'];

        $salt=constants::SALT;
        $password = sha1($salt.$password);
        $query="select * from merchants where email = '$email' and password='$password'";
        $stmt=$db->query($query);
        $num = $stmt->num_rows;

        if($num>0){

            session_start();
            session_regenerate_id();
            $session = session_id();

            while($row=$stmt->fetch_assoc()){

                $id = $row['id'];
                //setcookie($session, $id, time()+$this::SESSION_DURATION,"/");
                //$_SESSION[$session] = $id;

                $ses = array();
                $ses['id'] = $id;
                $ses['token'] = $session;
                $this->logUserSession($ses);

                $row['session_token'] = $session;
                extract($row);
                $this->data = $row;
            }

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();

        }else{
            $this->error = $this::ERR;
            $this->error_stmt = "Invalid email or password";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }
    }

    function addUni($data){
        $db = $this->dbConnect();
        $name = $data['name'];
        $state = $data['state'];
        $status = '1';
        $query = $db->prepare("INSERT INTO university(name,state,status) VALUES (?,?,?)");
        $query->bind_param("sss",$name,$state,$status);
        if($query->execute()){
            $this->data = $db->insert_id;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }else{
            $this->error = $this::ERR;
            $this->error_stmt = "Could not insert";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }
    }

    function addAudio($data){
        /*$uploaddir = constants::AUDIO_FOLDER;
        $base = basename($_FILES['audio']['name']);
        $uploadfile = $uploaddir . $base;

        $file_ext = 'mp3';

        if (file_exists($uploadfile)) {
            $base = time() . '.' . $file_ext;
            $uploadfile = $uploaddir. $base;
        }


        $uploaded = move_uploaded_file($_FILES['audio']['tmp_name'], $uploadfile);


        if(!$uploaded){
            $this->error = $this::ERR;
            $this->error_stmt = "File size is too big";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }*/

        $title = $data['title'];
        $body = $data['body'];
        $audio = 'audio';
        //$link = $data['link'];
        $link = $data['audio_id'];

        $db = $this->dbConnect();
        $query = $db->prepare("INSERT INTO content(title,body,image,type,date_uploaded) VALUES (?,?,?,?,NOW())");
        $query->bind_param("ssss",$title,$body,$link,$audio);
        if($query->execute()){
            $this->data = $db->insert_id;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }else{
            $this->error = $this::ERR;
            $this->error_stmt = "Could not insert";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }


    }

    function addProductCategory($data){
        $db = $this->dbConnect();
        $name = $data['name'];

        $query = $db->prepare("INSERT INTO product_category(category_name) VALUES (?)");
        $query->bind_param("s",$name);
        if($query->execute()){
            $this->data = $db->insert_id;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }else{
            $this->error = $this::ERR;
            $this->error_stmt = "Could not insert";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }
    }

    function addServiceCategory($data){
        $db = $this->dbConnect();
        $name = $data['name'];

        $query = $db->prepare("INSERT INTO service_category(category_name) VALUES (?)");
        $query->bind_param("s",$name);
        if($query->execute()){
            $this->data = $db->insert_id;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }else{
            $this->error = $this::ERR;
            $this->error_stmt = "Could not insert";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }
    }

    function addState($data){
        $db = $this->dbConnect();
        $name = $data['name'];
        $status = '1';
        $query = $db->prepare("INSERT INTO state(name,status) VALUES (?,?)");
        $query->bind_param("ss",$name,$status);
        if($query->execute()){
            $this->data = $db->insert_id;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }else{
            $this->error = $this::ERR;
            $this->error_stmt = "Could not insert";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }
    }



    function updateVerification($data){
        $this->error = 1;
        $db = $this->dbConnect();
        $link = $data['link'];
        $query="select id,verified from merchants where verify_url = '$link' ";

        $result=$db->query($query);
        if(!$result){
            $this->error_stmt = "Already verified";
        }
        if($row=$result->fetch_assoc())
        {
            $id = $row['id'];

            $query = "UPDATE merchants SET verified='1', verify_url='' WHERE id='$id' LIMIT 1";
            $db->query($query);

            $this->error_stmt = "Your email address verification was successful";
            $this->error = 0;
            $this->data = $id;

        }else{
            $this->error = 1;
            $this->error_stmt = "Already verified";
        }

        if($this->client==constants::INT_REQ){
            return $this->output();
        }
        $this->output();
    }

    function addAd($data){
        $db = $this->dbConnect();
        $page = $data['page'];
        $url = $data['url'];
        $img_str = $data['img_src'];
        $status = $data['status'];

        if(empty($img_str)){

            $query = "UPDATE ads SET ads_link='$url', ads_status='$status' WHERE ads_id='$page' LIMIT 1";
        }else{

            $op['pic_col'] = "ads_pic";
            $op['table'] = "ads";
            $op['id'] = $page;
            $op['id_col'] = "ads_id";
            $this->deleteOldFiles2($op);

            $vals['image'] = $img_str;
            $vals['original'] = 1;
            $upload = $this->uploadFileBase64Format($vals);
            if($upload===false){
                $this->error = $this::ERR_FILE;
                $this->error_stmt = "Could not upload image";

                if($this->client==constants::INT_REQ){
                    return $this->output();
                }

                $this->output();
            }

            $pic = $upload['base'];

            $query = "UPDATE ads SET ads_pic='$pic', ads_link='$url', ads_status='$status' WHERE ads_id='$page' LIMIT 1";

        }

        if($db->query($query)){
            $this->data = $page;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }
            $this->output();
        }else{

            print_r($db->error_list); die();

            $this->error = $this::ERR;
            $this->error_stmt = "Could not update";
            if($this->client==constants::INT_REQ){
                return $this->output();
            }
            $this->output();
        }


    }

    function resetPassword($data){

        $db = $this->dbConnect();
        $pwd = $data['password'];
        $salt=constants::SALT;

        $password = sha1($salt.$pwd);
        $email = $data['email'];


        $query="select * from merchants where email = '$email' ";

        $result=$db->query($query);
        if(!$result){

            $this->error = $this::ERR;
            $this->error_stmt = "Invalid login details";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();

        }
        if($row=$result->fetch_assoc())
        {
            $email_row = $row['email'];

            $query = "UPDATE merchants SET password='$password', password_reset='0' WHERE email='$email_row' LIMIT 1";

            if($db->query($query)){
                $this->data = "Password reset was successful";

                if($this->client==constants::INT_REQ){
                    return $this->output();
                }

                $this->output();
            }else{
                $this->error_stmt = "An error occurred";
                $this->error = $this::ERR;

                if($this->client==constants::INT_REQ){
                    return $this->output();
                }

                $this->output();
            }

        }else{
            $this->error_stmt = "An error occurred";
            $this->error = $this::ERR;

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }
    }

    function forgotPassword($data){
        $db = $this->dbConnect();
        $email = $data['email'];

        $query = "SELECT id,password FROM merchants WHERE email='$email' LIMIT 1 ";
        $statement=$db->query($query);
        $row=$statement->fetch_row();
        if(count($row) == 0){

            $this->error = $this::ERR;
            $this->error_stmt = "Email does not exists in our records";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();

        }else{
            session_start();
            session_regenerate_id();
            $reset = session_id();
            $query = "UPDATE merchants SET password_reset='$reset' WHERE email='$email' LIMIT 1";
            if($db->query($query)){

                $base_url = $this->getBaseUrl();
                $link = $base_url . '/reset.php?reset=' . $reset;
                $yr = date("Y");

                $logo_link = $base_url . '/assets/images/logo.png';

                $sender_email = constants::NO_REPLY_EMAIL;
                $subject = "CampusHub Notifications";

                $message = "
						<html>
						<head>
							<title>$subject</title>
						</head>
						<body style='font-family:Trebuchet MS, Arial, Helvetica, sans-serif;'>
							<div style='width:75%;float:left;background-color:#ffffff;padding:5%;border-radius:4px;color:rgba(0,0,0,0.9);box-shadow:0 2px 5px 0 rgba(0,0,0,0.36);text-align:center;font-weight:500;margin:auto 10%'>
							
							    <img src='$logo_link' />
								
								<h4 style='font-size:20px'>Password Reset Notification </h4>
								<p style='font-size:16px'> Click on the link below to reset your password</p>
								<br>
								
								<a href='$link'>Reset Link</a>
								<p>If the link does not work, copy the url below and paste in your browser address bar</p>
								<h5>$link </h5>
								
								
								<a href='#'><span style='padding-top:40px;font-size:12px'>&copy; $yr. CampusHub</span></a>
							</div>
						</body>
						</html>	";

                $headers = "MIME-Version: 1.0" . "\r\n";
                $headers.= "Content-type: text/html; charset= iso-8859-1" . "\r\n";
                $headers.= "From: $sender_email" . "\r\n";
                $headers.= "Reply-To: $sender_email" . "\r\n";
                mail($email,$subject,$message,$headers); // send email to user

                $this->data = $row[0];
                $this->error_stmt = "A password reset link has been sent to your email address";

                if($this->client==constants::INT_REQ){
                    return $this->output();
                }

                $this->output();


            }else{

                $this->error = $this::ERR;
                $this->error_stmt = "An error occurred";

                if($this->client==constants::INT_REQ){
                    return $this->output();
                }

                $this->output();
            }
        }
    }

    function addUser($data){
        /*echo $data['resource'];
        die();*/
        //$salt=$this->salt;

        $email = $data['email'];
        $email_exists = $this->checkEmail($email);
        if($email_exists > 0){
            $this->error = $this::ERR;
            $this->error_stmt = "Email exists";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }

        $db = $this->dbConnect();

        $salt=constants::SALT;
        $normal_pwd = $data['password'];
        $data['password'] = sha1($salt.$data['password']);

        session_start();
        session_regenerate_id();
        $session = session_id();
        $verify = sha1($salt.$session);

        $surname = $data['surname'];
        $firstname = $data['firstname'];
        $email = $data['email'];

        $query = $db->prepare("INSERT INTO merchants(picture,email,password,surname,firstname,phone,state,school,verify_url,verified,available,login_from,password_normal,reg_date) VALUES (?,?,?,?,?,?,?,?,?,'0','1',?,?,NOW())");
        $query->bind_param("sssssssssss",$data['picture'],$data['email'],$data['password'],$data['surname'],$data['firstname'],$data['phone'],$data['state'],$data['school'],$verify,$data['login_from'],$normal_pwd);
        if($query->execute())
        {

            //Send verification mail to user

            $base_url = $this->getBaseUrl();
            $link = $base_url . '/verify.php?link=' . $verify;
            $logo_link = $base_url . '/assets/images/logo.png';
            $yr = date("Y");

            $sender_email = constants::NO_REPLY_EMAIL;
            $subject = "CampusHub Notifications";
            $message = "
			<html>
			<head>
				<title>$subject</title>
			</head>
			<body style='font-family:Trebuchet MS, Arial, Helvetica, sans-serif;'>
				
				<div style='width:75%;float:left;background-color:#e8eaf6;padding:5%;border-radius:4px;color:rgba(0,0,0,0.9);box-shadow:0 2px 5px 0 rgba(0,0,0,0.36);text-align:center;font-weight:500;margin:auto 10%'>
						<img src='$logo_link' />
					
					<h4 style='font-size:20px'>Verification Notification </h4>
					<p style='font-size:16px'> Hi $surname $firstname</p>
					<br>
					<p>Thank you for registering with CampusHub.</p>
					<p>Please verify your email address by clicking on the link below</p>
					<a href='$link'>Verify My Email</a>
					<p>If the link does not work, copy the url below and paste in your browser address bar</p>
					<h5>$link </h5>
					
					
					<a href='#'><span style='padding-top:40px;font-size:12px'>&copy; $yr. CampusHub</span></a>
				</div>
			</body>
			</html>	";

            $headers = "MIME-Version: 1.0" . "\r\n";
            $headers.= "Content-type: text/html; charset= iso-8859-1" . "\r\n";
            $headers.= "From: $sender_email" . "\r\n";
            $headers.= "Reply-To: $sender_email" . "\r\n";
            mail($email,$subject,$message,$headers);

            $id = $db->insert_id;
            //setcookie($session, $id, time()+$this::SESSION_DURATION,"/");
            //$_SESSION[$session] = $id;
            $ses = array();
            $ses['id'] = $id;
            $ses['token'] = $session;
            $this->logUserSession($ses);

            $rez['id'] = $id;
            $rez['session_token'] = $session;

            $this->data = $rez;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();

        }else{
            $this->error = $this::ERR;
            $this->error_stmt = "Registration failed";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }
    }

    function addItem($data){
        $db = $this->dbConnect();

        $uid = $this->getUserFromToken($data['user']);
        if($uid===false){
            $this->error = $this::ERR_SESSION_EXP;
            $this->error_stmt = $this::SESSION_EXPIRED;

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }

        $name = $data['name'];
        $cat = $data['category'];
        $state = $data['state'];
        $sch = $data['sch'];
        $desc = $data['desc'];
        $price = $data['price'];
        $extra_pics = $data['pictures'];

        $query = $db->prepare("INSERT INTO product(user_id,name,category,state,school,description,price,approved,featured,post_date) VALUES (?,?,?,?,?,?,?,'0','0',?)");
        $query->bind_param("ssssssss",$uid,$name,$cat,$state,$sch,$desc,$price,$this->date);
        if($query->execute())
        {
            $id = $db->insert_id;
            //setcookie($session, $id, time()+$this::SESSION_DURATION,"/");
            //$_SESSION[$session] = $id;

            if(isset($extra_pics) && !empty($extra_pics)){
                $cnt = 0;
                $images = json_decode($extra_pics, true);
                $forum = $this::PRODUCT_FORUM;
                foreach($images as $v){
                    if($cnt == 5){
                        break;
                    }
                    $cnt++;
                    $query1 = "INSERT INTO photos(product_id,source,forum) VALUES (?,?,?)";
                    $stmt1 = $db->prepare($query1);
                    $stmt1->bind_param("sss",$id,$v,$forum);
                    $stmt1->execute();
                }
            }

            $this->client = constants::INT_REQ;

            $opt['table'] = "merchants";
            $opt['columns'] = "picture,surname,firstname";
            $opt['where_clause'] = "WHERE id = '$uid'";

            $response = $this->getAll($opt);
            $pic = $response['data'][0]['picture'];
            $firstN = $response['data'][0]['firstname'];
            $surN = $response['data'][0]['surname'];

            $n['page'] = $this::PRODUCT_FORUM;
            $n['page_id'] = $id;
            $n['user'] = 0;
            $n['type'] = 0;
            $n['pic'] = $pic;
            $n['content'] = $surN . " " . $firstN . " uploaded an item you may like";
            $n['actor'] = $uid;
            //$this->addNotification($n);

            $this->client = constants::EXT_REQ;

            $this->data = $id;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();

        }else{
            $this->error = $this::ERR;
            $this->error_stmt = "Could not upload product";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }

    }

    function addService($data){
        $db = $this->dbConnect();

        $uid = $this->getUserFromToken($data['user']);
        if($uid===false){
            $this->error = $this::ERR_SESSION_EXP;
            $this->error_stmt = $this::SESSION_EXPIRED;

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }

        $name = $data['name'];
        $cat = $data['category'];
        $state = $data['state'];
        $sch = $data['sch'];
        $desc = $data['desc'];
        $extra_pics = $data['pictures'];

        //echo $this->date."--".$uid."--".$name."--".$cat."--".$state."--".$sch."--".$desc."--".$extra_pics; die();

        $query = $db->prepare("INSERT INTO service(user_id,name,category,state,school,description,approved,featured,post_date) VALUES (?,?,?,?,?,?,'0','0',?)");
        $query->bind_param("sssssss",$uid,$name,$cat,$state,$sch,$desc,$this->date);

        if($query->execute())
        {
            $id = $db->insert_id;
            //setcookie($session, $id, time()+$this::SESSION_DURATION,"/");
            //$_SESSION[$session] = $id;

            if(isset($extra_pics) && !empty($extra_pics)){
                $cnt = 0;
                $images = json_decode($extra_pics, true);
                $forum = $this::SERVICE_FORUM;
                foreach($images as $v){
                    if($cnt == 5){
                        break;
                    }
                    $cnt++;
                    $query1 = "INSERT INTO photos(product_id,source,forum) VALUES (?,?,?)";
                    $stmt1 = $db->prepare($query1);
                    $stmt1->bind_param("sss",$id,$v,$forum);
                    $stmt1->execute();
                }
            }

            $this->data = $id;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();

        }else{
            $this->error = $this::ERR;
            $this->error_stmt = "Could not upload product";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }

    }

    function addVerificationItem($data){
        $db = $this->dbConnect();
        $id_card = $data['id_card'];
        $live_photo = $data['photo'];

        $uid = $this->getUserFromToken($data['token']);
        if($uid===false){
            $this->error = $this::ERR_SESSION_EXP;
            $this->error_stmt = $this::SESSION_EXPIRED;

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }
        $verified_state = "1";

        if($stmt = $db->prepare("UPDATE merchants SET live_photo=?,id_card=?,verified_photo=? WHERE id=? LIMIT 1 ")){
            $stmt->bind_param('ssss',$live_photo,$id_card,$verified_state,$uid);
            $stmt->execute();
            $stmt->close();

            $this->data = $uid;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();

        }else{

            print_r($db->error_list); die();
            $this->error = $this::ERR;
            $this->error_stmt = "Could not update";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }

    }


    function addEvent($data){
        $db = $this->dbConnect();

        $name = $data['title'];
        $desc = $data['content'];
        $school = $data['school'];
        $state = $data['state'];
        $date = $data['date'];
        $venue = $data['venue']; //image_str
        $img_str = $data['image_str'];
        $ad1 = $data['ad_image_str1'];
        $ad2 = $data['ad_image_str2'];
        $ad3 = $data['ad_image_str3'];
        $ad4 = $data['ad_image_str4'];

        $desc_extra = $data['content_extra'];
        $ad_url = $data['ad_url'];
        $ad_pic_str = $data['ad_image_str'];

        $vals['image'] = $img_str;
        $upload = $this->uploadFileBase64Format($vals);
        if($upload===false){
            $this->error = $this::ERR_FILE;
            $this->error_stmt = "Could not upload image";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }

        $pic = $upload['base'];

        //Upload the Ad Image
        $ad_pic = "";
        if(!empty($ad_pic_str)){
            $valsAd['image'] = $ad_pic_str;
            $uploadAd = $this->uploadFileBase64Format($valsAd);
            if($uploadAd===false){
                $this->error = $this::ERR_FILE;
                $this->error_stmt = "Could not upload ad image";

                if($this->client==constants::INT_REQ){
                    return $this->output();
                }

                $this->output();
            }

            $ad_pic = $uploadAd['base'];

        }


        $query = $db->prepare("INSERT INTO event(picture,name,venue,state,school,description,event_date,ad_link,ad_pic,description_extra,ad_pic1,ad_pic2,ad_pic3,ad_pic4,post_date) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,NOW())");
        $query->bind_param("ssssssssssssss",$pic,$name,$venue,$state,$school,$desc,$date,$ad_url,$ad_pic,$desc_extra,$ad1,$ad2,$ad3,$ad4);
        if($query->execute()){
            $id = $db->insert_id;
            $this->data = $id;


            $n['page'] = $this::EVENT_FORUM;
            $n['page_id'] = $id;
            $n['user'] = 0;
            $n['type'] = 0;
            $n['pic'] = $pic;
            $n['actor'] = 0;
            $n['content'] = "An event '" .$name. "' was uploaded";
            $this->addNotification($n);


            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();

        }else{

            print_r($db->error_list);
            die();

            $this->error = $this::ERR;
            $this->error_stmt = "Could not upload event";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }
    }

    function addAlert($data){
        $db = $this->dbConnect();
        $uid = $data['uid'];
        $product = $data['product'];
        $category = $data['category'];
        $state = $data['state'];
        $school = $data['school'];

        $query = $db->prepare("INSERT INTO alert(alert_product,alert_user,alert_category,alert_state,alert_school) VALUES (?,?,?,?,?)");
        $query->bind_param("sssss",$product,$uid,$category,$state,$school);
        if($query->execute()){
            $id = $db->insert_id;
            $this->data = $id;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();

        }else{
            $this->error = $this::ERR;
            $this->error_stmt = "Could not add alert";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }


    }

    function addReport($data){
        $db = $this->dbConnect();
        $user_id = $data['uid'];
        $page_id = $data['target_id'];
        $comment = $data['reason'];
        $type = $data['type'];
        $forum = $data['source'];

        /*

        send_report&type=" + type + "&target_id=" + targetId + "&reason=" + encodedMsg+ "&source=" + source + "&link=" + link +

        */
        $query = "INSERT INTO report(report_page_id,report_user,report_comment,report_type,report_forum,report_date) VALUES(?,?,?,?,?,?,?)";

        //echo $page_id ."::".$user_id."::".$comment."::".$parent."::".$type."::".$this->date; die();

        $statement = $db->prepare($query);
        $statement->bind_param("sssssss",$page_id,$user_id,$comment,$type,$forum,$this->date);
        if($statement->execute()){
            $insert_id = $db->insert_id;

            return $insert_id;
        }else{
            return false;
        }
    }

    function addComment($data){
        $db = $this->dbConnect();
        $user_id = $data['uid'];
        $page_id = $data['pid'];
        $comment = $data['comment'];
        $type = $data['type'];
        $parent = $data['parent'];
        $forum = $data['forum'];

        $opt1['table'] = "merchants";
        $opt1['where_clause'] = "WHERE id='$user_id'";
        $opt1['limit'] = "LIMIT 1";
        $this->client = constants::INT_REQ;
        $dt = $this->getAll($opt1);
        $info = $dt['data'][0];
        $surname = $info['surname'];
        $firstname = $info['firstname'];
        $username = $info['username'];
        $picture = $info['picture'];
        $this->client = constants::EXT_REQ;


        /*if($type=="topic"){
            $query = "INSERT INTO xnx2_253_market_comments(mc_data,mc_user,mc_comment,mc_parent,mc_link,mc_date) VALUES(?,?,?,?,?,NOW())";
        }elseif($type=="poll"){
            $query = "INSERT INTO xnx2_253_poll_comments(pc_data,pc_user,pc_comment,pc_parent,pc_link,pc_date) VALUES(?,?,?,?,?,NOW())";
        }*/
        $query = "INSERT INTO comment(comment_page_id,comment_user,comment_comment,comment_parent,comment_type,comment_forum,comment_date) VALUES(?,?,?,?,?,?,?)";

        //echo $page_id ."::".$user_id."::".$comment."::".$parent."::".$type."::".$this->date; die();

        $statement = $db->prepare($query);
        $statement->bind_param("sssssss",$page_id,$user_id,$comment,$parent,$type,$forum,$this->date);
        if($statement->execute()){
            $insert_id = $db->insert_id;

            $notify_to = 0;
            $notify_content = $surname . " " . $firstname . " commented on an item";
            if($type==1){
                $this->client = constants::INT_REQ;

                $op['table'] = "comment";
                $op['where_clause'] = "WHERE comment_id='$parent'";
                $op['column'] = "comment_user";
                $op['limit'] = "LIMIT 1";
                $dt0 = $this->getAll($op);
                $info0 = $dt0['data'][1];
                $notify_to = $info0['comment_user'];

                //print_r($info0); die();

                //$notify_to = $parent;
                $notify_content = $surname . " " . $firstname . " replied to your comment";

                $this->client = constants::EXT_REQ;
            }

            $n['page'] = $forum;
            $n['page_id'] = $page_id;
            $n['user'] = $notify_to;
            $n['type'] = $type;
            $n['pic'] = $picture;
            $n['content'] = $notify_content;
            $n['actor'] = $user_id;
            if($user_id!=$notify_to && $notify_to!=0){
                $this->addNotification($n);
            }

            $this->client = constants::INT_REQ;
            //Get the owner of the item/service that this user($firstname) commented on
            $tab = ($forum=="product")?"product":"service";
            $opt2['table'] = $tab;
            $opt2['columns'] = "user_id";
            $opt2['where_clause'] = "WHERE id = '$page_id'";
            $resp2 = $this->getAll($opt2);
            if($type==1){
                $owner_id = $resp2['data'][2]['user_id'];
            }else{
                $owner_id = $resp2['data'][1]['user_id'];
            }

            $this->client = constants::EXT_REQ;

            //print_r($owner_id); die();


            if($owner_id!=$user_id){ //Check if commenter is the owner of the product/service
                $n1['page'] = $forum;
                $n1['page_id'] = $page_id;
                $n1['user'] = $owner_id;
                $n1['type'] = $type;
                $n1['pic'] = $picture;
                $n1['actor'] = $user_id;
                $n1['content'] = $surname . " " . $firstname . " commented on your " . $forum;
                $this->addNotification($n1);
            }



            return $insert_id;
        }else{
            return false;
        }

    }

    function addNotification($data){

        $db = $this->dbConnect();
        $content = $data['content'];
        $status = "0";
        $page = $data['page'];
        $page_id = $data['page_id'];
        $user = $data['user'];
        $type = $data['type'];
        $pic = $data['pic'];
        $actor = $data['actor'];
        $date = $this->date;


        $user_fcm = "";
        if($user > 0){
            $query="select fcm from merchants where id = '$user' LIMIT 1 ";
            $stmt=$db->query($query);
            $row = $stmt->fetch_row();
            $user_fcm = $row[0];
        }


        require_once __DIR__ . '/firebase.php';
        require_once __DIR__ . '/push.php';

 
        $firebase = new Firebase();
        $push = new Push();
 
        // optional payload
        $payload = array();
        $payload['page'] = $page;
        $payload['page_id'] = $page_id;
 
        // notification title
        $title = 'CampusHub Notification';
         
        // notification message
        $message = $content;
         
        // push type - single user / topic
        $push_type = 'individual';
         
        // whether to include to image or not
        $include_image = FALSE;

        //Add to notification table
        $query = "INSERT INTO notify(notify_content, notify_page, notify_page_id, notify_user, notify_type, notify_pic,notify_status, notify_activated_by, notify_date) VALUES (?,?,?,?,?,?,?,?,?)";
        $stmt = $db->prepare($query);
        $stmt->bind_param("sssssssss",$content,$page,$page_id,$user,$type,$pic,$status,$actor,$date);
        $stmt->execute();
 
 
        $push->setTitle($title);
        $push->setMessage($message);
        /*
        if ($include_image) {
            $push->setImage('https://api.androidhive.info/images/minion.jpg');
        } else {
            $push->setImage('');
        }
        */
        $push->setImage('');
        $push->setIsBackground(TRUE);
        $push->setPayload($payload);
 
 
        $json = '';
        $response = '';
 
        /*
        if ($push_type == 'topic') {
            $json = $push->getPush();
            $response = $firebase->sendToTopic('global', $json);
        } else if ($push_type == 'individual') {
            $json = $push->getPush();
            $regId = isset($_GET['regId']) ? $_GET['regId'] : 'e1AJ0azn95Y:APA91bEGZWS1rFJnWYuOLMvjzl4IYLw9aMCaXnMuGsaglX0KAwdKfSjcycyDlof-D6Sn5nvLokMCXmQunM_TKlVDD1LRKHhQ0TxPQF6-BH53WZyB9crUeRVJASPSwLpzHxHrCATMnu3u';
            
            //die("sender");
            
            $response = $firebase->send($regId, $json);
        }
        */

        if ($user < 1) {
            $json = $push->getPush();
            $response = $firebase->sendToTopic('event', $json);
        } else if ($user > 0) {
            $json = $push->getPush();
            $regId = $user_fcm;
            
            //die("sender");
            
            $response = $firebase->send($regId, $json);
        }

    }

    function getUserFromFacebook($data){
        $db = $this->dbConnect();

        $email = $data['email'];
        if($this->checkEmail($email) > 0){
            $query="select * from merchants where email = '$email' and login_from = 'facebook' ";
            $stmt=$db->query($query);
            $num = $stmt->num_rows;

            if($num>0){

                $session = $this->generateSessionID();

                while($row=$stmt->fetch_assoc()){

                    $id = $row['id'];
                    //setcookie($session, $id, time()+$this::SESSION_DURATION,"/");

                    //setcookie("_ucmo","3",time()+3600 * 24,"/");


                    //$_SESSION[$session] = $id;

                    $ses = array();
                    $ses['id'] = $id;
                    $ses['token'] = $session;
                    $this->logUserSession($ses);

                    $row['session_token'] = $session;
                    extract($row);
                    $this->data = $row;
                }

                if($this->client==constants::INT_REQ){
                    return $this->output();
                }

                $this->output();

            }else{
                $this->error = $this::ERR_FB;
                $this->error_stmt = "Facebook Account Unverified";

                if($this->client==constants::INT_REQ){
                    return $this->output();
                }

                $this->output();
            }
        }else{
            $this->error = $this::ERR_FB;
            $this->error_stmt = "Facebook Account Unrecorded";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }
    }

    function testCookie(){
        //setcookie("_ucmo","44",time()+3600 * 24,"/");
        session_start();
        $_SESSION['haa'] = "22";

    }

    function addPayPoint($data){

        $m_no = $data['manager_no'];
        $address = $data['address'];
        $type = $data['type'];
        $query = $this->db->prepare("INSERT INTO pay_point(manager_no,address,type) VALUES (?,?,?)");
        $query->bind_param("sss",$m_no,$address,$type);
        if($query->execute())
        {
            return true;

        }else{
            return false;
        }
    }

    function addCategory($image_name,$image_str,$image_ext,$name,$set_banner){

        $image_name = preg_replace('/\s+/', '', $image_name).time();
        $dir = '../assets/img/banners/'.$image_name;
        $save_img = $image_name.".".$image_ext;

        $image_url = $this->base64_to_img($image_str,$dir,$image_ext);

        if(!$image_url){
            return false;
        }
        $query = $this->db->prepare("INSERT INTO category(name,pic_ref,set_as_banner) VALUES (?,?,?)");
        $query->bind_param("sss",$name,$save_img,$set_banner);
        if($query->execute())
        {
            return true;

        }else{
            return false;
        }

    }

    function addLiveDeal($data){

        $uploaddir = 'assets/docs/';
        $base = basename($_FILES['pdf']['name']);
        $uploadfile = $uploaddir . $base;

        $file_ext = 'pdf';

        if (file_exists($uploadfile)) {
            $base = time() . '.' . $file_ext;
            $uploadfile = $uploaddir. $base;
        }
        //$avail = 'yes';

        $uploaded = move_uploaded_file($_FILES['pdf']['tmp_name'], $uploadfile);

        if(!$uploaded){
            return false;
        }
        $status = (isset($data['avail']))?1:0;

        $query = $this->db->prepare("INSERT INTO live_deals(lot,asking_price,gross_return,net_return,weekly_return,annual_rent,statement,status,date) VALUES (?,?,?,?,?,?,?,?,NOW())");
        $query->bind_param("ssssssss",$data['lot'],$data['asking_price'],$data['gross_return'],$data['net_return'],$data['weekly_return'],$data['annual_rent'],$base,$status);
        if($query->execute())
        {
            return true;

        }else{
            return false;
        }

    }

    function updateProfile($vals){
        $db = $this->dbConnect();
        $id = $vals['id'];

        $update_fields = "";

        $email = $vals['email'];
        if(isset($email)){
            $update_fields .= "email='$email'";
        }

        $surname = $vals['surname'];
        if(isset($surname)){
            /*if(strlen($update_fields) > 0){
                $update_fields .= ", location='$addr'";
            }else{
                $update_fields .= "location='$addr'";
            }*/
            $update_fields .= (strlen($update_fields) > 0)?", surname='$surname'":"surname='$surname'";
        }
        $firstname = $vals['firstname'];
        if($firstname){
            if(strlen($update_fields) > 0){
                $update_fields .= ", firstname='$firstname'";
            }
            $update_fields .= (strlen($update_fields) > 0)?", firstname='$firstname'":"firstname='$firstname'";
        }
        $phone = $vals['phone'];
        if(isset($phone)){
            if(strlen($update_fields) > 0){
                $update_fields .= ", phone='$phone'";
            }
            $update_fields .= (strlen($update_fields) > 0)?", phone='$phone'":"phone='$phone'";
        }
        $state = $vals['state'];
        if(isset($state)){
            if(strlen($update_fields) > 0){
                $update_fields .= ", state='$state'";
            }
            $update_fields .= (strlen($update_fields) > 0)?", state='$state'":"state='$state'";
        }
        $picture = $vals['picture'];
        if(isset($picture)){

            $this->deleteOldFiles("picture","merchants",$id);

            if(strlen($update_fields) > 0){
                $update_fields .= ", picture='$picture'";
            }
            $update_fields .= (strlen($update_fields) > 0)?", picture='$picture'":"picture='$picture'";
        }
        $school = $vals['school'];
        if(isset($school)){
            if(strlen($update_fields) > 0){
                $update_fields .= ", school='$school'";
            }
            $update_fields .= (strlen($update_fields) > 0)?", school='$school'":"school='$school'";
        }
        $hide_email = $vals['hide_email'];

        if(isset($hide_email)){
            if(strlen($update_fields) > 0){
                $update_fields .= ", hide_email='$hide_email'";
            }
            $update_fields .= (strlen($update_fields) > 0)?", hide_email='$hide_email'":"hide_email='$hide_email'";
        }

        $hide_phone = $vals['hide_phone'];
        if(isset($hide_phone)){
            if(strlen($update_fields) > 0){
                $update_fields .= ", hide_phone='$hide_phone'";
            }
            $update_fields .= (strlen($update_fields) > 0)?", hide_phone='$hide_phone'":"hide_phone='$hide_phone'";
        }

        $fcm = $vals['fcm'];
        if(isset($fcm)){
            if(strlen($update_fields) > 0){
                $update_fields .= ", fcm='$fcm'";
            }
            $update_fields .= (strlen($update_fields) > 0)?", fcm='$fcm'":"fcm='$fcm'";
        }

        $new_pwd = $vals['new_pwd'];
        $old_pwd = $vals['old_pwd'];
        if(isset($new_pwd)){

            $salt=constants::SALT;
            $old_pwd = sha1($salt.$old_pwd);
            $new_pwd = sha1($salt.$new_pwd);

            $query="select id from merchants where id = '$id' and password='$old_pwd'";
            $stmt=$db->query($query);
            $num = $stmt->num_rows;
            if($num < 1){
                $this->error = $this::ERR_NO_VALUE;
                $this->error_stmt = "Old password is not correct";
                if($this->client==constants::INT_REQ){
                    return $this->output();
                }
                $this->output();
            }

            if(strlen($update_fields) > 0){
                $update_fields .= ", password='$new_pwd'";
            }
            $update_fields .= (strlen($update_fields) > 0)?", password='$new_pwd'":"password='$new_pwd'";
        }

        $query = "UPDATE merchants SET ".$update_fields." WHERE id = '$id' LIMIT 1";

        if($db->query($query)){
            $this->data = $id;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }
            $this->output();
        }else{
            $this->error = $this::ERR;
            $this->error_stmt = "Could not update";
            if($this->client==constants::INT_REQ){
                return $this->output();
            }
            $this->output();
        }
    }

    function updateEvent($vals){
        $db = $this->dbConnect();
        $id = $vals['id'];
        $title = $vals['title'];
        $content = $vals['content'];
        $date = $vals['date'];
        $image_name = $vals['image_name'];
        $former_pic = $vals['former_name'];
        $venue = $vals['venue'];
        $content_extra = $vals['content_extra'];
        $ad_url = $vals['ad_url'];
        $ad_image_str = $vals['ad_image_str'];

        if(strlen($image_name) > 1){
            unlink(constants::IMG_FOLDER.$former_pic);
            unlink(constants::IMG_THUMB.$former_pic);
            $img_str = $vals['image_str'];

            $vals['image'] = $img_str;
            $upload = $this->uploadFileBase64Format($vals);
            if($upload===false){
                $this->error = $this::ERR_FILE;
                $this->error_stmt = "Could not upload image";

                if($this->client==constants::INT_REQ){
                    return $this->output();
                }

                $this->output();
            }

            $former_pic = $upload['base'];

        }

        if(empty($ad_image_str)){

            //$query = "UPDATE ads SET ads_link='$url', ads_status='$status' WHERE ads_id='$page' LIMIT 1";
            if($stmt = $db->prepare("UPDATE event SET picture=?,name=?,venue=?, description=?,event_date=?,description_extra=?,ad_link=? WHERE id=? LIMIT 1 ")){
                $stmt->bind_param('ssssssss',$former_pic,$title,$venue,$content,$date,$content_extra,$ad_url,$id);
                $stmt->execute();
                $stmt->close();

                $this->data = $id;
                if($this->client==constants::INT_REQ){
                    return $this->output();
                }

                $this->output();

            }else{


                print_r($db->error_list); die();
                $this->error = $this::ERR;
                $this->error_stmt = "Could not update";

                if($this->client==constants::INT_REQ){
                    return $this->output();
                }

                $this->output();
            }


        }else {

            //$query = "UPDATE event SET picture=?,name=?,venue=?, description=?,event_date=? WHERE id=? LIMIT 1 ";

            $op['pic_col'] = "ad_pic";
            $op['table'] = "event";
            $op['id'] = $id;
            $op['id_col'] = "id";
            $this->deleteOldFiles2($op);

            $valsAd['image'] = $ad_image_str;
            $uploadAd = $this->uploadFileBase64Format($valsAd);
            if($uploadAd===false){
                $this->error = $this::ERR_FILE;
                $this->error_stmt = "Could not upload Ad image";

                if($this->client==constants::INT_REQ){
                    return $this->output();
                }

                $this->output();
            }

            $ad_pic = $uploadAd['base'];

            if($stmt = $db->prepare("UPDATE event SET picture=?,name=?,venue=?, description=?,event_date=?,description_extra=?,ad_pic=?,ad_link=? WHERE id=? LIMIT 1 ")){
                $stmt->bind_param('sssssssss',$former_pic,$title,$venue,$content,$date,$content_extra,$ad_pic,$ad_url,$id);
                $stmt->execute();
                $stmt->close();

                $this->data = $id;
                if($this->client==constants::INT_REQ){
                    return $this->output();
                }

                $this->output();

            }else{

                $this->error = $this::ERR;
                $this->error_stmt = "Could not update";

                if($this->client==constants::INT_REQ){
                    return $this->output();
                }

                $this->output();
            }


        }

        //$query = "UPDATE event SET picture='$former_pic',name='$title',venue='$venue', description='$content',event_date='$date' WHERE id='$id' LIMIT 1 ";

        /*if($db->query($query)){
            $this->data = $id;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }else{

            $this->error = $this::ERR;
            $this->error_stmt = "Could not update";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }*/

    }

    function updateProduct($vals){
        $db = $this->dbConnect();
        $id = $vals['id'];
        $name = $vals['name'];
        $cat = $vals['category'];
        $state = $vals['state'];
        $sch = $vals['sch'];
        $desc = $vals['desc'];
        $price = $vals['price'];
        $extra_pics = $vals['pictures'];
        $date = $this->date;
        $approved = "0";

        //$query = "UPDATE product SET name='$name',category='$cat',state='$state', school='$sch',description='$desc',price='$price' WHERE id='$id' LIMIT 1 ";

        $query = "UPDATE product SET name='$name',category='$cat',state='$state', school='$sch',description='$desc',price='$price',approved='0',post_date='$date' WHERE id='$id' LIMIT 1 ";

        /*
        print_r("UPDATE product SET name='$name',category='$cat',state='$state', school='$sch',description='$desc',price='$price',approved='0',post_date='$date' WHERE id='$id' LIMIT 1 ");
        die();
        */


        //$stmt = $db->prepare("UPDATE product SET name=?,category=?,state=?, school=?,description=?,price=?,approved=?,post_date=? WHERE id=? LIMIT 1 ");

        if($stmt = $db->prepare("UPDATE product SET name=?,category=?,state=?, school=?,description=?,price=?,approved=?,post_date=? WHERE id=? LIMIT 1 ")){
            $stmt->bind_param('sssssssss',$name,$cat,$state,$sch,$desc,$price,$approved,$date,$id);
            $stmt->execute();
            $stmt->close();

            $this->data = $id;

            if(isset($extra_pics) && !empty($extra_pics)){
                $images = json_decode($extra_pics, true);
                $forum = $this::PRODUCT_FORUM;
                foreach($images as $v){
                    $query1 = "INSERT INTO photos(product_id,source,forum) VALUES (?,?,?)";
                    $stmt1 = $db->prepare($query1);
                    $stmt1->bind_param("sss",$id,$v,$forum);
                    $stmt1->execute();
                }
            }

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();

        }else{
            $this->error = $this::ERR;
            $this->error_stmt = "Could not update";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }


        /*
        if($db->query($query)){
            $this->data = $id;

            if(isset($extra_pics) && !empty($extra_pics)){
                $images = json_decode($extra_pics, true);
                foreach($images as $v){
                    $query1 = "INSERT INTO photos(product_id,source) VALUES (?,?)";
                    $stmt1 = $db->prepare($query1);
                    $stmt1->bind_param("ss",$id,$v);
                    $stmt1->execute();
                }
            }

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }else{

            $this->error = $this::ERR;
            $this->error_stmt = "Could not update";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }
        */

    }

    function updateMany($props){
        $db = $this->dbConnect();

        $table = $props['table'];
        $col = $props['col'];
        $id_col = $props['id_col'];
        $id = $props['id'];
        $val = $props['val'];
        //$query = "UPDATE ".$table." SET ".$col." = '$val' WHERE ".$id_col." = '$id' LIMIT 1";

        //die("UPDATE ".$table." SET ".$col." = '$val' WHERE ".$id_col." IN( '$id' )");

        $affected_id = explode(",",$id);
        for($x=0;$x<count($affected_id);$x++){
            $currId = $affected_id[$x];
            $stmt = $db->prepare("UPDATE ".$table." SET ".$col." = ? WHERE ".$id_col." = ? ");
            $stmt->bind_param('ss',$val,$currId);
            $stmt->execute();
            $stmt->close();
        }

        $this->data = $id;
        if($this->client==constants::INT_REQ){
            return $this->output();
        }

        $this->output();
    }

    function updateAny($props){
        $db = $this->dbConnect();

        $table = $props['table'];
        $col = $props['col'];
        $id_col = $props['id_col'];
        $id = $props['id'];
        $val = $props['val'];
        //$query = "UPDATE ".$table." SET ".$col." = '$val' WHERE ".$id_col." = '$id' LIMIT 1";
        if($stmt = $db->prepare("UPDATE ".$table." SET ".$col." = ? WHERE ".$id_col." = ? LIMIT 1")){
            $stmt->bind_param('ss',$val,$id);
            $stmt->execute();
            $stmt->close();

            $this->data = $id;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();

        }else{

            $this->error = $this::ERR;
            $this->error_stmt = "Could not update";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }
    }

    function editLiveDeal($values_arr){

        $status = (isset($values_arr['avail']))?1:0;
        $lot = $values_arr['lot'];
        $asking_price = $values_arr['asking_price'];
        $gross_return = $values_arr['gross_return'];
        $net_return = $values_arr['net_return'];
        $weekly_return = $values_arr['weekly_return'];
        $annual_rent = $values_arr['annual_rent'];
        $id = $values_arr['id'];

        if(empty($_FILES['pdf']['name'])){
            $query = "UPDATE live_deals SET lot='$lot', asking_price='$asking_price', gross_return='$gross_return', net_return='$net_return', weekly_return='$weekly_return', annual_rent='$annual_rent', status='$status' WHERE id='$id' LIMIT 1 ";

        }else{
            $this->deleteOldFiles("statement","live_deals",$id);

            $uploaddir = 'assets/docs/';
            $base = basename($_FILES['pdf']['name']);
            $uploadfile = $uploaddir . $base;

            $file_ext = 'pdf';

            if (file_exists($uploadfile)) {
                $base = time() . '.' . $file_ext;
                $uploadfile = $uploaddir. $base;
            }
            //$avail = 'yes';

            $uploaded = move_uploaded_file($_FILES['pdf']['tmp_name'], $uploadfile);

            if(!$uploaded){
                return false;
            }

            $query = "UPDATE live_deals SET lot='$lot', asking_price='$asking_price', gross_return='$gross_return', net_return='$net_return', weekly_return='$weekly_return', annual_rent='$annual_rent', status='$status', statement='$base' WHERE id='$id' LIMIT 1 ";
        }

        if($this->db->query($query)){
            return "true";
        }else{
            return "false";
        }

    }

    function hitAdmin($data){

        $db = $this->dbConnect();
        $uid = $data['uid'];
        $content = $data['content'];
        $dept = $data['dept'];

        $opt1['table'] = "merchants";
        $opt1['where_clause'] = "WHERE id='$uid'";
        $opt1['limit'] = "LIMIT 1";
        $this->client = constants::INT_REQ;
        $dt = $this->getAll($opt1);
        $info = $dt['data'][0];
        $surname = $info['surname'];
        $firstname = $info['firstname'];
        $username = $info['username'];
        $picture = $info['picture'];
        $u_email = $info['email'];
        $this->client = constants::EXT_REQ;

        $query = "INSERT INTO inquiry(inquiry_user_id,inquiry_content,inquiry_type,inquiry_date) VALUES(?,?,?,?)";

        //echo $page_id ."::".$user_id."::".$comment."::".$parent."::".$type."::".$this->date; die();

        $statement = $db->prepare($query);
        $statement->bind_param("ssss",$uid,$content,$dept,$this->date);
        if($statement->execute()){
            $insert_id = $db->insert_id;

            $year = date('Y');
            $email = constants::OFFICIAL_EMAIL . ",nnabugwu.michael@gmail.com";

            $sender_email = $u_email;
            $subject = "CampusHub Notifications";
            $message = "
			<html>
			<head>
				<title>$subject</title>
			</head>
			<body style='font-family:Trebuchet MS, Arial, Helvetica, sans-serif;'>
				<div style='width:75%;float:left;background-color:#ffffff;padding:5%;border-radius:4px;color:rgba(0,0,0,0.9);box-shadow:0 2px 5px 0 rgba(0,0,0,0.36);text-align:center;font-weight:500;margin:auto 10%'>
					
					<h4 style='font-size:20px'>CampusHub Notification </h4>
					<p style='font-size:16px'> $surname $firstname made a complain/inquiry</p>
					<br>
					
					
					<a href='#'><span style='padding-top:40px;font-size:12px'>&copy; $year. CampusHub</span></a>
				</div>
			</body>
			</html>	";

            $headers = "MIME-Version: 1.0" . "\r\n";
            $headers.= "Content-type: text/html; charset= iso-8859-1" . "\r\n";
            $headers.= "From: $sender_email" . "\r\n";
            $headers.= "Reply-To: $sender_email" . "\r\n";
            mail($email,$subject,$message,$headers); // send email to admin

            return $insert_id;
        }else{
            return false;
        }
    }

    function updateNumber($vals){
        $id = $vals['id'];
        $no = $vals['number'];
        $email = $vals['email'];
        $query = "UPDATE users SET number='$no' WHERE id='$id' LIMIT 1";
        if($this->db->query($query)){

            $sender_email = "premiuma360@gmail.com";
            $subject = "Charter Hall Premium Notifications";
            $message = "
			<html>
			<head>
				<title>$subject</title>
			</head>
			<body style='font-family:Trebuchet MS, Arial, Helvetica, sans-serif;'>
				<div style='width:75%;float:left;background-color:#ffffff;padding:5%;border-radius:4px;color:rgba(0,0,0,0.9);box-shadow:0 2px 5px 0 rgba(0,0,0,0.36);text-align:center;font-weight:500;margin:auto 10%'>
					
					<h4 style='font-size:20px'>Premium Number Notification </h4>
					<p style='font-size:16px'> You have been assigned a premium number</p>
					<br>
					
					<h4>Your premium number is $no </h4>
					
					<a href='#'><span style='padding-top:40px;font-size:12px'>&copy; 2018. Charter Hall Premium</span></a>
				</div>
			</body>
			</html>	";

            $headers = "MIME-Version: 1.0" . "\r\n";
            $headers.= "Content-type: text/html; charset= iso-8859-1" . "\r\n";
            $headers.= "From: $sender_email" . "\r\n";
            $headers.= "Reply-To: $sender_email" . "\r\n";
            mail($email,$subject,$message,$headers); // send email to admin

            return "true";
        }else{
            return "false";
        }

    }

    function updateAccount($data){
        $id = $data['id'];
        $cap = $data['capital'];
        $profit = $data['profit'];
        $bonus = $data['bonus'];
        if(!is_numeric($cap) || !is_numeric($profit) || !is_numeric($bonus)){
            return false;
        }

        $query = "UPDATE users SET capital='$cap', profit='$profit', bonus='$bonus' WHERE id='$id' LIMIT 1";
        if($this->db->query($query)){
            return true;
        }else{
            return false;
        }
    }

    function updatePayPoint($data){
        $m_no = $data['manager_no'];
        $address = $data['address'];

        $query = "UPDATE pay_point SET address='$address' WHERE manager_no='$m_no' LIMIT 1";
        if($this->db->query($query)){
            return true;
        }else{
            return false;
        }
    }

    function addManager($data){
        /*echo $data['resource'];
        die();*/
        $query = $this->db->prepare("INSERT INTO managers(email,number) VALUES (?,?)");
        $query->bind_param("ss",$data['email'],$data['number']);
        if($query->execute())
        {
            return $this->db->insert_id;

        }else{
            return false;
        }
    }

    function updateOrder($data){
        $id = $data['id'];
        $ref = $data['ref'];
        $query="select confirm from payment where id = '$id' AND confirm = '0' ";
        $result=$this->db->query($query);
        if(!$result){
            return 0; //db error occurred
        }
        if($row=$result->fetch_assoc()) //has paid but not yet confirmed
        {
            $query = "UPDATE payment SET ref='$ref', confirm='1' WHERE id = '$id' LIMIT 1 ";
            if($this->db->query($query)){
                return $id;
            }

        }else{ //has already confirmed
            return -1;
        }
    }

    function editCategory($image_name,$image_str,$image_ext,$name,$set_banner,$change_image,$id){
        if($change_image == 1){

            $image_name = preg_replace('/\s+/', '', $image_name).time();
            $dir = '../assets/img/banners/'.$image_name;
            $save_img = $image_name.".".$image_ext;

            $image_url = $this->base64_to_img($image_str,$dir,$image_ext);

            if(!$image_url){
                return false;
            }

            $query = "UPDATE category SET name='$name', set_as_banner='$set_banner', pic_ref='$save_img' WHERE id = '$id' LIMIT 1 ";

        }else{
            $query = "UPDATE category SET name='$name', set_as_banner='$set_banner' WHERE id = '$id' LIMIT 1 ";

        }

        if($this->db->query($query)){
            return true;
        }else{
            return false;
        }

    }

    function getDetails($table,$id){
        $query = "SELECT * FROM " . $table . " WHERE id='$id' LIMIT 1";
        $stmt = $this->db->query($query);
        $num = $stmt->num_rows;
        if($num>0){
            $values = array();
            while($row=$stmt->fetch_assoc()){
                extract($row);
                $values[] = $row;
            }

            /*if($table=="users"){
                $invited_by = $values[0]['invited_by'];
                if(!empty($invited_by)){
                   $query1 = "SELECT email FROM users WHERE id='$invited_by' LIMIT 1";
                    $stmt = $this->db->query($query1);
                    while($row=$stmt->fetch_assoc()){
                        $values[0]['invited_by'] = $row['email'];
                    }
                }
            }*/

            return $values[0];
        }else{
            return false;
        }
    }

    function getUserFromToken($token){
        $db = $this->dbConnect();

        $query="select * from user_session where token = '$token' LIMIT 1 ";
        $result=$db->query($query);

        if($row=$result->fetch_assoc())
        {

            /*$res = array();
            $res['id'] = $row['id'];
            $res['email'] = $row['email'];
            return $res;*/
            $id = $row['user_id'];

            $extend = date('Y-m-d h:i:s', strtotime(' +6 month'));

            $query1 = "UPDATE user_session SET expiry='$extend' WHERE token='$token' LIMIT 1";
            $db->query($query1);

            return $id;

        }else{
            return false;
        }

        /*$id = $_SESSION[$token];
        if(isset($id)){
            //renew the session
            //setcookie($token, $id, time()+$this::SESSION_DURATION,"/");
            $_SESSION[$token] = $id;
            return $id;
        }else{
            return false;
        }*/
    }

    function countUsersOnline(){
        $data = $this->returnActiveUsers();
        $this->data = $data['count'];
        if($this->client==constants::INT_REQ){
            return $this->output();
        }

        $this->output();
    }

    function checkUserLike($data){
        $uid = $data['uid'];
        $type = $data['type'];
        $id = $data['id'];
        $forum = $data['forum'];

        $db = $this->dbConnect();
        //check if user likes this topic
        $query = "SELECT likes_id FROM likes WHERE likes_user = '$uid' AND likes_page_id = '$id' AND likes_page='$type' AND likes_forum='$forum' LIMIT 1 ";
        $stmt = $db->query($query);
        $likes = $stmt->num_rows;

        return $likes;
    }

    function likePost($data){
        $db = $this->dbConnect();

        $type = $data['type'];
        $id = $data['id'];
        $uid = $data['uid'];
        $forum = $data['forum'];

        $query0 = "SELECT likes_id FROM likes WHERE likes_page_id = '$id' AND likes_page='$type' ";
        $stmt0 = $db->query($query0);
        $num_likes = $stmt0->num_rows;

        $query = "SELECT likes_id FROM likes WHERE likes_page_id = '$id' AND likes_user = '$uid' AND likes_page='$type' LIMIT 1 ";
        $stmt = $db->query($query);
        $row0 = $stmt->fetch_row();
        $num = $stmt->num_rows;
        if($num == 0){
            $query = "INSERT INTO likes(likes_user, likes_page_id, likes_page,likes_forum,likes_date) VALUES(?,?,?,?,?) ";
            $stmt = $db->prepare($query);
            $stmt->bind_param("sssss",$uid,$id,$type,$forum,$this->date);
            if($stmt->execute()) {
                $insert_id = $db->insert_id;

                if($forum=="product" || $forum=="service"){

                    $this->client = constants::INT_REQ;
                    /**
                     * Insert into notification table
                     */

                    //Get the liker
                    $opt['table'] = "merchants";
                    $opt['columns'] = "picture,surname,firstname";
                    $opt['where_clause'] = "WHERE id = '$uid'";

                    $response = $this->getAll($opt);
                    $pic = $response['data'][0]['picture'];
                    $firstN = $response['data'][0]['firstname'];
                    $surN = $response['data'][0]['surname'];

                    //Get the owner of the item/service that was liked
                    $tab = ($forum=="product")?"product":"service";
                    $opt2['table'] = $tab;
                    $opt2['columns'] = "user_id";
                    $opt2['where_clause'] = "WHERE id = '$id'";
                    $resp2 = $this->getAll($opt2);
                    $owner_id = $resp2['data'][1]['user_id'];

                    if($forum=="product"){
                        $msg = $surN. " " . $firstN . " liked your item";
                    }else{
                        $msg = $surN. " " . $firstN . " recommended your service";
                    }

                    if($uid!==$owner_id){
                        if($type==0){
                            $n['page'] = $forum;
                            $n['page_id'] = $id;
                            $n['user'] = $owner_id;
                            $n['type'] = 0;
                            $n['pic'] = $pic;
                            $n['content'] = $msg;
                            $n['actor'] = $uid;
                            $this->addNotification($n);
                        }
                    }

                    $this->client = constants::EXT_REQ;
                }


                $res['id'] = $insert_id;
                $res['action'] = "liked";
                $res['likes'] = $num_likes + 1;
                $this->data = $res;
                $this->output();
            }else{
                $this->error = $this::ERR_PREP;
                $this->output();
            }

        }else{
            $stmt = $db->prepare("DELETE FROM likes WHERE likes_user = ? AND likes_page_id = ? AND likes_page = ? ");
            $stmt->bind_param("sss", $uid,$id,$type);
            if($stmt->execute()){
                $res['id'] = $row0[0];
                $res['action'] = "disliked";
                $res['likes'] = $num_likes - 1;
                $this->data = $res;
                $this->output();
            }else{
                $this->error = $this::ERR_PREP;
                $this->output();
            }
        }

    }

    function notify($data){
        $db = $this->dbConnect();

        $time = date('Y-m-d H:i:s');
        $content = $data['content'];
        $page = $data['page'];
        $page_id = $data['page_id'];
        $user = $data['user'];
        $pic = $data['pic'];
        $status = 0;

        $query = $db->prepare("INSERT INTO notify(notify_content,notify_status,notify_page,notify_page_id,notify_user,notify_pic,notify_date) VALUES (?,?,?,?,?,?,?)");
        $query->bind_param("sssssss",$content,$status,$page,$page_id,$user,$pic,$time);
        $query->execute();
    }

    function countNewNotifs($data){
        $db = $this->dbConnect();
        $uid = $data['id'];
        $last_id = $data['last_id'];

        $query = "SELECT * FROM notify WHERE notify.notify_user = '$uid' AND notify.notify_id > '$last_id' AND notify.notify_status = '0' AND notify.notify_activated_by != '$uid' LIMIT 10";
        $stmt = $db->query($query);
        $num = $stmt->num_rows;

        $this->data = $num;
        $this->output();
    }

    function updateReadNotifs($data){
        $db = $this->dbConnect();
        $id = $data['id'];
        $uid = $data['uid'];
        $query = "SELECT notify_user,notify_read_users FROM notify WHERE notify_id = '$id'";
        $stmt = $db->query($query);
        $row = $stmt->fetch_row();
        $user = $row[0];
        $read_users = $row[1];
        if($user=='0'){
            if(empty($read_users) || $read_users=='0'){
                $mk = $uid;
            }else{
                $ids = explode(",",$read_users);
                if(!in_array($uid,$ids)){
                    $mk = $read_users . "," . $uid;
                }else{
                    $mk = $read_users;
                }
            }
            $query2 = "UPDATE notify SET notify_read_users='$mk' WHERE notify_id='$id' LIMIT 1";
            $db->query($query2);
        }else{
            $query1 = "UPDATE notify SET notify_read='1' WHERE notify_id='$id' LIMIT 1";
            $db->query($query1);
        }

    }

    function updateSeenNotifs($data){
        $db = $this->dbConnect();
        $uid = $data['id'];
        $last_id = $data['last_id'];
        $least_id = $last_id + 1;

        //echo $least_id; die();

        $query0 = "SELECT * FROM notify WHERE (notify.notify_user = '$uid' OR notify.notify_user = '0') AND notify.notify_status = '0' AND notify.notify_id < '$least_id' ORDER BY notify.notify_id DESC LIMIT 10";
        $stmt0 = $db->query($query0);
        while($row=$stmt0->fetch_assoc()){
            $notify_id = $row['notify_id'];
            $notify_user = $row['notify_user'];
            $notify_seen_users = $row['notify_seen_users'];

            /*if(empty($notify_seen_users)){
                echo "it's null";
            }*/


            if($notify_user=='0'){ //if it's a general notification for everybody...

                //update the column in such a way to indicate that this user has seen the notification
                if(empty($notify_seen_users) || $notify_seen_users=='0'){
                    $mk = $uid;
                }else{

                    $ids = explode(",",$notify_seen_users);
                    if(!in_array($uid,$ids)){
                        $mk = $notify_seen_users . "," . $uid;
                    }else{
                        $mk = $notify_seen_users;
                    }

                }

                //echo $mk." & ".$notify_id; die();

                $query2 = "UPDATE notify SET notify_seen_users='$mk' WHERE notify_id='$notify_id' LIMIT 1";
                $db->query($query2);

            }else{
                $query1 = "UPDATE notify SET notify_status='1' WHERE notify_id='$notify_id' LIMIT 1";
                $db->query($query1);
            }

        }

    }

    function getAllNotif($data){
        $db = $this->dbConnect();
        $uid = $data['id'];
        $start = $data['start'];
        $start = (isset($start))?$start:0;
        $limit = 20;

        //$query0 = "SELECT notify_id FROM notify WHERE notify.notify_user = '$uid' AND notify.notify_id > '$last_id' AND notify.notify_status = '0' LIMIT 10";
        /*$query0 = "SELECT notify_id FROM notify WHERE notify.notify_user = '$uid' AND notify.notify_status = '0' LIMIT 10";
        $stmt0 = $db->query($query0);
        $num0 = $stmt0->num_rows;
        $this->data['count'] = $num0;*/

        $result_array = array();

        /*$query = "SELECT * FROM notify WHERE (notify.notify_user = '$uid' OR notify.notify_user = '0') AND notify.notify_status = '0' ORDER BY notify.notify_id DESC LIMIT $start,$limit";
        $stmt = $db->query($query);*/

        $query = "SELECT * FROM notify WHERE (notify.notify_user = '$uid' OR notify.notify_user = '0') AND notify.notify_activated_by != '$uid' ORDER BY notify.notify_id DESC LIMIT $start,$limit";
        $stmt = $db->query($query);

        //$num = $stmt->num_rows;
        //echo $num; die();
        

        while($row=$stmt->fetch_assoc()){

            $notify_user = $row['notify_user'];
            
            //echo $notify_user;
            
            extract($row);
            //$this->data['info'] = $row;
            

            if($notify_user > 0){
                //notify the user immediately since the notify_user is specific
                $result_array[] = $row;
                continue;
                //$this->output();

            }else{
                //
                //echo("notify id is 00 0h");
                //die();
                
                
                if($row['notify_page'] == $this::PRODUCT_FORUM ){
                    $pid = $row['notify_page_id'];

                    $query1 = "SELECT name,category,state,school,user_id FROM product WHERE id = '$pid' AND approved = '1' LIMIT 1";
                    $stmt1 = $db->query($query1);
                    $row1=$stmt1->fetch_row();
                    if(count($row1) > 0){
                        $pname = $row1[0];
                        $pcat = $row1[1];
                        $pstate = $row1[2];
                        $pschool = $row1[3];
                        $user_id = $row1[4];

                        //check if the user that uploaded the product is the same as the user that's about to get this notification
                        if($user_id!=$uid){
                            //Check if user has set some alerts
                            $query2 = "SELECT * FROM alert WHERE alert_user = '$uid'";
                            $stmt2 = $db->query($query2);
                            $num2 = $stmt2->num_rows;
                            //If user has set some alerts...
                            if($num2 > 0){
                                //go through all alerts and check if any matches the item
                                while($row2=$stmt2->fetch_assoc()){
                                    $alert_name = $row2['alert_product'];
                                    $alert_cat = $row2['alert_category'];
                                    $alert_state = $row2['alert_state'];
                                    $alert_school = $row2['alert_school'];

                                    $alert_state_arr = explode(",",$alert_state);
                                    $alert_school_arr = explode(",",$alert_school);
                                    //preg_match('/\bare\b/', $a)
                                    //strpos($a, 'are')
                                    $preg_char = '/\b'.$alert_name.'\b/';
                                    /*
                                    if(in_array($pstate,$alert_state_arr) && in_array($pschool,$alert_school_arr) && $alert_cat == $pcat && preg_match($preg_char, $pname))
                                    {
                                        $result_array[] = $row;
                                        continue;
                                        //$this->output();
                                    }
                                    */

                                    if(in_array($pstate,$alert_state_arr) && in_array($pschool,$alert_school_arr) && preg_match($preg_char, $pname))
                                    {
                                        $result_array[] = $row;
                                        continue;
                                        //$this->output();
                                    }

                                }

                            }else{ //else if the user no get any preferences
                                //just output
                                $result_array[] = $row;
                                continue;
                                //$this->output();
                            }
                        }

                    }

                }else{
                    if($row['notify_page'] == $this::EVENT_FORUM){
                    //Notify all users if it's an event post
                        $result_array[] = $row;
                        continue;
                    }
                    
                }
                
            }

            //$res['data'] = $row;
        }

        $this->data = $result_array;
        $this->output();
    }

    function countUnseenNotifications($data){

        $db = $this->dbConnect();
        $uid = $data['id'];
        $limit = 10;

        $result_array = array();
        $cnt = 0;

        /*$query = "SELECT * FROM notify WHERE (notify.notify_user = '$uid' OR notify.notify_user = '0') AND notify.notify_status = '0' ORDER BY notify.notify_id DESC LIMIT 0,$limit";
        $stmt = $db->query($query);*/

        $query = "SELECT * FROM notify WHERE (notify.notify_user = '$uid' OR notify.notify_user = '0') AND notify.notify_activated_by != '$uid' ORDER BY notify.notify_id DESC LIMIT 0,$limit";
        $stmt = $db->query($query);

        //$num = $stmt->num_rows;

        while($row=$stmt->fetch_assoc()){

            $notify_user = $row['notify_user']; //this column is either 0 for general or an actual value of specific user id

            extract($row);
            //$this->data['info'] = $row;

            if($notify_user > 0){
                //notify the user immediately since the notify_user is specific

                $result_array[] = $row;
                continue;
                //$this->output();

            }else{
                
                
                if($row['notify_page'] == $this::PRODUCT_FORUM ){
                    $pid = $row['notify_page_id'];

                    $query1 = "SELECT name,category,state,school,user_id FROM product WHERE id = '$pid' AND approved = '1' LIMIT 1";
                    $stmt1 = $db->query($query1);
                    $row1=$stmt1->fetch_row();
                    if(count($row1) > 0){
                        $pname = $row1[0];
                        $pcat = $row1[1];
                        $pstate = $row1[2];
                        $pschool = $row1[3];
                        $user_id = $row1[4];

                        //check if the user that uploaded the product is the same as the user that's about to get this notification
                        if($user_id!=$uid){
                            //Check if user has set some alerts
                            $query2 = "SELECT * FROM alert WHERE alert_user = '$uid'";
                            $stmt2 = $db->query($query2);
                            $num2 = $stmt2->num_rows;
                            //If user has set some alerts...
                            if($num2 > 0){
                                //go through all alerts and check if any matches the item
                                while($row2=$stmt2->fetch_assoc()){
                                    $alert_name = $row2['alert_product'];
                                    $alert_cat = $row2['alert_category'];
                                    $alert_state = $row2['alert_state'];
                                    $alert_school = $row2['alert_school'];

                                    $alert_state_arr = explode(",",$alert_state);
                                    $alert_school_arr = explode(",",$alert_school);
                                    //preg_match('/\bare\b/', $a)
                                    //strpos($a, 'are')
                                    $preg_char = '/\b'.$alert_name.'\b/';
                                    /*
                                    if(in_array($pstate,$alert_state_arr) && in_array($pschool,$alert_school_arr) && $alert_cat == $pcat && preg_match($preg_char, $pname))
                                    {
                                        $result_array[] = $row;
                                        continue;
                                        //$this->output();
                                    }
                                    */

                                    if(in_array($pstate,$alert_state_arr) && in_array($pschool,$alert_school_arr) && preg_match($preg_char, $pname))
                                    {
                                        $result_array[] = $row;
                                        continue;
                                        //$this->output();
                                    }

                                }

                            }else{ //else if the user no get any preferences
                                //just output
                                $result_array[] = $row;
                                continue;
                                //$this->output();
                            }
                        }

                    }

                }elseif($row['notify_page'] == $this::EVENT_FORUM){
                    //Notify all users if it's an event post
                    $result_array[] = $row;
                    continue;
                }
                
            }

            //$res['data'] = $row;
        }


        for($i=0;$i<count($result_array);$i++){
            $v = $result_array[$i];
            $user = $v['notify_user'];
            $status = $v['notify_status'];
            $seen_users = $v['notify_seen_users'];

            //echo "<br>".$v['notify_id'];

            if($user==$uid){ //if this notification is for a single user
                //echo "<br>"."single".$status;
                if($status==0){
                    $cnt++;
                }
            }else{ //else if this notification is for multiple users
                //echo "<br>"."many";
                if(!empty($seen_users)){ //some have seen it. check if this user has seen it
                    $seen_users_array = explode(",",$seen_users);
                    if(!in_array($uid,$seen_users_array)){
                        $cnt++;
                    }
                }else{ //nobody has seen it. so add it
                    $cnt++;
                }
            }

        }

        //echo "<br>".$cnt;

        //die();

        return $cnt;

    }

    /*

    function countUnseenNotifications($data){
        $db = $this->dbConnect();
        $uid = $data['id'];
        $limit = 10;

        $counted = 0;

        $query = "SELECT * FROM notify WHERE (notify.notify_user = '$uid' OR notify.notify_user = '0') AND notify.notify_status = '0' ORDER BY notify.notify_id DESC LIMIT 0,$limit";
        $stmt = $db->query($query);
        //$num = $stmt->num_rows;

        while($row=$stmt->fetch_assoc()){

            $notify_user = $row['notify_user']; //this column is either 0 for general or an actual value of specific user id
            $status = $row['notify_status'];
            $seen_users = $row['notify_seen_users']; //all users that have seen this notification
            if($notify_user=='0'){ //if this notification is not for a single user
                if($status=='1'){
                    $counted++;
                }
            }else{ //else if this notification is for multiple users
                if(!empty($seen_users)){
                    $seen_users_array = explode(",",$seen_users);
                    if(in_array($uid,$seen_users_array)){
                        $counted++;
                    }
                }
            }

        }

        return $counted;

    }

    */

    function checkNotif($data){
        $db = $this->dbConnect();
        $uid = $data['id'];
        $last_id = $data['last_id'];

        //$query0 = "SELECT notify_id FROM notify WHERE notify.notify_user = '$uid' AND notify.notify_id > '$last_id' AND notify.notify_status = '0' LIMIT 10";
        /*
        $query0 = "SELECT notify_id FROM notify WHERE notify.notify_user = '$uid' AND notify.notify_status = '0' LIMIT 10";
        $stmt0 = $db->query($query0);
        $num0 = $stmt0->num_rows;
        */
        //$this->data['count'] = $num0;


        $this->data['count'] = $this->countUnseenNotifications($data);

        //echo $this->countUnseenNotifications($data); die();


        $query = "SELECT * FROM notify WHERE (notify.notify_user = '$uid' OR notify.notify_user = '0') AND notify.notify_id > '$last_id' AND notify.notify_status = '0' AND notify.notify_activated_by != '$uid' ORDER BY notify.notify_id DESC LIMIT 1";
        $stmt = $db->query($query);
        $num = $stmt->num_rows;

        if($num>0){

            while($row=$stmt->fetch_assoc()){

                $notify_user = $row['notify_user'];

                extract($row);
                //$this->data['info'] = $row;
                if($notify_user > 0){
                    //notify the user immediately since the notify_user is specific
                    $this->data['info'] = $row;
                    continue;
                    //$this->output();

                }else{

                    if($row['notify_page'] == $this::PRODUCT_FORUM ){
                        $pid = $row['notify_page_id'];

                        $query1 = "SELECT name,category,state,school,user_id FROM product WHERE id = '$pid' AND approved = '1' LIMIT 1";
                        $stmt1 = $db->query($query1);
                        $row1=$stmt1->fetch_row();
                        if(count($row1) > 0){
                            $pname = $row1[0];
                            $pcat = $row1[1];
                            $pstate = $row1[2];
                            $pschool = $row1[3];
                            $user_id = $row1[4];

                            //check if the user that uploaded the product is the same as the user that's about to get this notification
                            if($user_id!=$uid){
                                //Check if user has set some alerts
                                $query2 = "SELECT * FROM alert WHERE alert_user = '$uid'";
                                $stmt2 = $db->query($query2);
                                $num2 = $stmt2->num_rows;
                                //If user has set some alerts...
                                if($num2 > 0){
                                    //go through all alerts and check if any matches the item
                                    while($row2=$stmt2->fetch_assoc()){
                                        $alert_name = $row2['alert_product'];
                                        $alert_cat = $row2['alert_category'];
                                        $alert_state = $row2['alert_state'];
                                        $alert_school = $row2['alert_school'];

                                        $alert_state_arr = explode(",",$alert_state);
                                        $alert_school_arr = explode(",",$alert_school);
                                        //preg_match('/\bare\b/', $a)
                                        //strpos($a, 'are')
                                        $preg_char = '/\b'.$alert_name.'\b/';
                                        /*
                                        if(in_array($pstate,$alert_state_arr) && in_array($pschool,$alert_school_arr) && $alert_cat == $pcat && preg_match($preg_char, $pname))
                                        {
                                            $this->data['info'] = $row;
                                            continue;
                                            //$this->output();
                                        }
                                        */
                                        if(in_array($pstate,$alert_state_arr) && in_array($pschool,$alert_school_arr) && preg_match($preg_char, $pname))
                                        {
                                            $this->data['info'] = $row;
                                            continue;
                                            //$this->output();
                                        }



                                    }

                                }else{ //else if the user no get any preferences
                                    //just output
                                    $this->data['info'] = $row;
                                    continue;
                                    //$this->output();
                                }
                            }

                        }

                    }elseif($row['notify_page'] == $this::EVENT_FORUM){
                        //Notify all users if it's an event post
                        $this->data['info'] = $row;
                        continue;
                    }else{
                        
                    }
                }

                //$res['data'] = $row;
            }

        }else{

            //$this->output();
        }

        $this->output();

    }

    function logUserSession($data){

        $db = $this->dbConnect();
        $token = $data['token'];
        $id = $data['id'];
        $expiry = date('Y-m-d h:i:s', strtotime(' +6 month'));
        $platform = $data['platform'];

        $query = $db->prepare("INSERT INTO user_session(user_id,token,platform,expiry,login_date) VALUES (?,?,?,?,NOW())");
        $query->bind_param("ssss",$id,$token,$platform,$expiry);
        $query->execute();

    }

    function unregisterSession($data){
        $db = $this->dbConnect();
        /*$token = $data['token'];
        //setcookie($token, "", time() - 1800,"/");
        $_SESSION[$token] = "";*/

        $platform = $data['platform'];
        $token = $data['token'];
        $stmt = $db->prepare("DELETE FROM user_session WHERE token = ? ");
        $stmt->bind_param("s", $token);
        $stmt->execute();


    }

    function returnActiveUsers(){
        $db = $this->dbConnect();
        $query="select DISTINCT user_id from user_session where expiry > NOW() ";
        $result=$db->query($query);
        $num = $result->num_rows;
        while($row=$result->fetch_assoc()){
            extract($row);
            //$this->data[] = $row;
        }

        $ret = array();
        $ret['count'] = $num;
        $ret['users'] = $row;
        return $ret;
    }

    function deleteProduct($data){
        $db = $this->dbConnect();
        $id = $data['id'];

        $query = "SELECT source FROM photos WHERE product_id IN($id) ";
        $stmt = $db->query($query);
        $num = $stmt->num_rows;
        if ($num > 0) {
            while ($row = $stmt->fetch_assoc()) {
                $img = $row['source'];
                $mPic = constants::IMG_FOLDER.$img;
                $thumb = constants::IMG_THUMB.$img;

                if (file_exists($mPic)) {
                    unlink($mPic);
                }
                if (file_exists($thumb)) {
                    unlink($thumb);
                }
            }
        }
        $query1 = "DELETE FROM photos WHERE product_id IN($id) ";
        $db->query($query1);
        $query1 = "DELETE FROM likes WHERE likes_page_id IN($id) AND likes_forum=" . $this::PRODUCT_FORUM;
        $db->query($query1);
        $query1 = "DELETE FROM comment WHERE comment_page_id IN($id) AND comment_forum=" . $this::PRODUCT_FORUM;
        $db->query($query1);
        //$query1 = "DELETE FROM product WHERE id = '$id' ";
        $query1 = "DELETE FROM product WHERE id IN($id) ";
        $confirm = $db->query($query1);

        if(!$confirm){
            $this->error = $this::ERR;
            $this->error_stmt = "Could not delete";
        }

        $this->output();

    }

    function deleteMerchant($data){
        $db = $this->dbConnect();
        $id = $data['id'];

        $query = "SELECT picture FROM merchants WHERE id IN($id) ";
        $stmt = $db->query($query);
        $num = $stmt->num_rows;
        if ($num > 0) {
            while ($row = $stmt->fetch_assoc()) {
                $img = $row['picture'];
                $mPic = constants::IMG_FOLDER.$img;
                $thumb = constants::IMG_THUMB.$img;

                if (file_exists($mPic)) {
                    unlink($mPic);
                }
                if (file_exists($thumb)) {
                    unlink($thumb);
                }
            }
        }

        $query = "SELECT photos.source,photos.id AS photo_id FROM photos LEFT JOIN product ON photos.product_id = product.id WHERE product.user_id ='$id' ";
        $stmt = $db->query($query);
        $num = $stmt->num_rows;
        if ($num > 0) {
            while ($row = $stmt->fetch_assoc()) {
                $img = $row['source'];
                $photo_id = $row['photo_id'];
                $mPic = constants::IMG_FOLDER.$img;
                $thumb = constants::IMG_THUMB.$img;

                if (file_exists($mPic)) {
                    unlink($mPic);
                }
                if (file_exists($thumb)) {
                    unlink($thumb);
                }


                $query11 = "DELETE FROM photos WHERE product_id = '$photo_id' ";
                $db->query($query11);
            }
        }

        $query1 = "DELETE FROM likes WHERE likes_user IN($id)";
        $db->query($query1);
        $query1 = "DELETE FROM comment WHERE comment_user IN($id)";
        $db->query($query1);
        //$query1 = "DELETE FROM product WHERE id = '$id' ";
        $query1 = "DELETE FROM product WHERE user_id IN($id) ";
        $db->query($query1);
        $query1 = "DELETE FROM service WHERE user_id IN($id) ";
        $db->query($query1);
        $query1 = "DELETE FROM merchants WHERE id ='$id' ";
        $confirm = $db->query($query1);


        if($confirm){
            $this->data = $id;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }else{
            $this->error = $this::ERR;
            $this->error_stmt = "Could not delete";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }

    }

    function deleteService($data){
        $db = $this->dbConnect();
        $id = $data['id'];

        $query = "SELECT source FROM photos WHERE product_id IN($id) ";
        $stmt = $db->query($query);
        $num = $stmt->num_rows;
        if ($num > 0) {
            while ($row = $stmt->fetch_assoc()) {
                $img = $row['source'];
                $mPic = constants::IMG_FOLDER.$img;
                $thumb = constants::IMG_THUMB.$img;

                if (file_exists($mPic)) {
                    unlink($mPic);
                }
                if (file_exists($thumb)) {
                    unlink($thumb);
                }
            }
        }
        $query1 = "DELETE FROM photos WHERE product_id IN($id) ";
        $db->query($query1);
        $query1 = "DELETE FROM likes WHERE likes_page_id IN($id) AND likes_forum=" . $this::SERVICE_FORUM;
        $db->query($query1);
        $query1 = "DELETE FROM comment WHERE comment_page_id IN($id) AND comment_forum=" . $this::SERVICE_FORUM;
        $db->query($query1);
        //$query1 = "DELETE FROM product WHERE id = '$id' ";
        $query1 = "DELETE FROM service WHERE id IN($id) ";
        $confirm = $db->query($query1);

        if(!$confirm){
            $this->error = $this::ERR;
            $this->error_stmt = "Could not delete";
        }

        $this->output();

    }

    function deleteRecord2($vals){
        $db = $this->dbConnect();

        $table = $vals['table'];
        $id_col = $vals['id_col'];
        $id = $vals['id'];


        $stmt = $db->prepare("DELETE FROM ". $table . " WHERE ".$id_col." = ? ");
        $stmt->bind_param("s", $id);


        if($stmt->execute()){
            $this->data = $id;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }else{
            $this->error = $this::ERR;
            $this->error_stmt = "Could not delete";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }
    }

    function deleteRecord($vals){
        $db = $this->dbConnect();

        $table = $vals['table'];
        $id = $vals['id'];

        /*if($table=="category"){
            $this->deleteOldFiles("pic_ref",$table,$id);
        }*/
        if($table=="event"){
            $this->deleteOldFiles("picture",$table,$id);
        }

        $stmt = $db->prepare("DELETE FROM ". $table . " WHERE id = ? ");
        $stmt->bind_param("s", $id);


        if($stmt->execute()){
            $this->data = $id;
            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }else{
            $this->error = $this::ERR;
            $this->error_stmt = "Could not delete";

            if($this->client==constants::INT_REQ){
                return $this->output();
            }

            $this->output();
        }
    }

    function deleteOldFiles2($data){

        $pic_col = $data['pic_col'];
        $table = $data['table'];
        $id = $data['id'];
        $id_col = $data['id_col'];

        $db = $this->dbConnect();
        $query = "SELECT " . $pic_col . "  FROM " . $table . " WHERE " . $id_col . " = ". $id;

        $stmt2 = $db->query($query);
        $num = $stmt2->num_rows;
        if(!$stmt2){

        }else{
            if($num > 0){
                while($row=$stmt2->fetch_assoc()){
                    //unlink("./assets/docs/".$row[$pic_col]);

                    if(!empty($row[$pic_col])){
                        if(file_exists(constants::IMG_FOLDER.$row[$pic_col])===true){
                            unlink(constants::IMG_FOLDER.$row[$pic_col]);
                        }

                        if(file_exists(constants::IMG_THUMB.$row[$pic_col])===true){
                            unlink(constants::IMG_THUMB.$row[$pic_col]);
                        }
                    }
                }
            }

        }

    }

    function deleteOldAudioFiles2($data){

        $pic_col = $data['pic_col'];
        $table = $data['table'];
        $id = $data['id'];
        $id_col = $data['id_col'];
        $folder = $data['folder'];

        $db = $this->dbConnect();
        $query = "SELECT " . $pic_col . "  FROM " . $table . " WHERE " . $id_col . " = ". $id;

        $stmt2 = $db->query($query);
        $num = $stmt2->num_rows;
        if(!$stmt2){

        }else{
            if($num > 0){
                while($row=$stmt2->fetch_assoc()){
                    //unlink("./assets/docs/".$row[$pic_col]);

                    if(!empty($row[$pic_col])){
                        if(file_exists($folder.$row[$pic_col])===true){
                            unlink($folder.$row[$pic_col]);
                        }
                    }
                }
            }

        }

    }

    function deleteOldFiles($pic_col,$table,$id){
        $db = $this->dbConnect();
        $query = "SELECT " . $pic_col . "  FROM " . $table . " WHERE id = ". $id;

        $stmt2 = $db->query($query);
        $num = $stmt2->num_rows;
        if(!$stmt2){

        }else{
            if($num > 0){
                while($row=$stmt2->fetch_assoc()){
                    //unlink("./assets/docs/".$row[$pic_col]);

                    if(file_exists(constants::IMG_FOLDER.$row[$pic_col])){
                        unlink(constants::IMG_FOLDER.$row[$pic_col]);
                    }

                    if(file_exists(constants::IMG_THUMB.$row[$pic_col])){
                        unlink(constants::IMG_THUMB.$row[$pic_col]);
                    }
                }
            }

        }

    }

    private function dbError(){

        $this->error = $this::DB_ERR;
        $this->error_stmt = "Sorry, server error occurred";
        $this->output();
    }

    function utf8ize($d) {
        if (is_array($d)) {
            foreach ($d as $k => $v) {
                $d[$k] = $this->utf8ize($v);
            }
        } else if (is_string ($d)) {
            return utf8_encode($d);
        }
        return $d;
    }

    function output(){

        $res = array();
        $res['error'] = $this->error;
        $res['error_stmt'] = $this->error_stmt;
        $res['data'] = $this->data;
        $res['date'] = $this->date;

        if($this->client==constants::INT_REQ){
            return $res;
        }

        header('Content-Type: application/json');

        echo json_encode($this->utf8ize($res));
        die();
    }

    function test(){
        /*$id = "5";
        $token = array();
        $token['id'] = $id;
        echo JWT::encode($token, 'secret_server_key');*/
        $db = $this->dbConnect();
        $id = 6;

        $query = "SELECT photos.source, photos.product_id, photos.id AS photo_id FROM photos LEFT JOIN product ON photos.product_id = product.id WHERE product.user_id ='$id' ";
        $stmt = $db->query($query);
        $num = $stmt->num_rows;
        if ($num > 0) {
            while ($row = $stmt->fetch_assoc()) {
                echo $row['product_id']. " : ". $row['photo_id']."<br>";
            }
        }else{
            echo "no data ".$num;
        }

    }

}



?>